
::    ****************************************************
::    *  
::    *  File:      GetTimeLeap_Job.cmd
::    *  Generated: by "C:\Program Files\Scripte\GetTimeLeap_Job_Make.cmd"
::    *  Author:    Kalle Koseck
::    *  Date:      2008-01-21
::    *  Revision:  
::    *  
::    *       EDIT: GetTimeLeap.cmd  ONLY
::    *  
::    ****************************************************
Set Debug=

@Call :Call_Init
@Set Call_=Call :


:: ***CutAnfg*** GetTimeLeap.cmd

:: cls&Call :GTLJ_Filename k&Exit /b 0

:: call pr&Cls&echo off
:: Mode CON cols=50 lines=25

:: *******************************************************************
:GetTimeLeap
:: Set Call_=Call &Set EchoLabel=Rem
Rem vvvvvvvvvv Anfg %0 vvvvvvvvvv
@If "%Call_%" EQU "" (Set Call_=Call )
@%Call_%Call_Init %0
@%Call_%Call_Help "%~1"
%EchoLabel% %0 Input:  "%~1"
::
::    ****************************************************
::    *  Autor:    Kalle Koseck
::    *  File:     GetTimeLeap
::    *  Datum:    2008-01-20
::    *  Revision: 
::    *
::    *  License:  GPL / GNU General Public License
::    *
::    *  Check for time leaps (jumps in system time)
::    *  (see below)
::    *  
::    *  THIS FILE GENERATES GetTimeLeap_Job.cmd
::    *  WITH:               GetTimeLeapJob_Make.cmd
::    *  
::    *  Start this application by:
::    *  
::    *    Start /MIN "Time Leap" "...\GetTimeLeapJob.cmd" "<Filename>.EXT"
::    *  
::    *  
::    *  Input:
::    *
%Hlp% *  Para1: String, Filename where to return the out-values
%Hlp% *         "%~1"
%Hlp% *         Format: Batch-File
::    *         EXT could be BAT resulting in <Filename>.BAT
::    *         or CMD: like <Filename>.CMD
::    *         if EXT is missing, BAT is appended to <Filename>
%Hlp% *  
::    *  if <Filename> is deleted by the starting application
::    *  (from outside):
::    *  EXIT this TimeLeap application at once.
::    *  
::    *  <Filename>.SYN: synchronization File
::    *  the SYN file is not explicitly given it is made the
::    *  filename in Para1, changing the extension to .SYN
::    *  or making it .SYN if no extension is supplied.
::    *    
::    *    if NOT EXIST: no action for synchronization
::    *    the length is not checked
::    *    
::    *    if it does EXIST:
::    *    if length (!) changed: the calling application
::    *    is still living, continue executing
::    *    changed means: lenght becomes shorter or longer
::    *    Timeout time longer than 60 seconds:
::    *    length not changed for longer than 60 sec:
::    *    exit directly,
::    *    DELETING the <Filename>.EXT and <Filename>.SYN
::    *    
::    *  Output:
::    *    
::    *  <Filename>.EXT e.g. .BAT to receive the values:
::    *         
::    *  GTLJ_Function: Integer
::    *    0  nothing detected, no errors
::    *    1  time leap found
::    *    
::    *  Format: Set GTLJ_Function=<Number>
::    *    
::    *  GTLJ_TimeDiff: Integer, Correction of the system time
::    *    0  no time leap found
::    *    (+): time correction positive, means the time
::    *         was advanced, some seconds were missing
::    *         e.g. time was 20:05:10 was set to 20:05:25
::    *         TimeDiff returns the value 15
::    *    (-): time correction negative, time set back
::    *  
::    *  Format: Set GTLJ_TimeDiff=<Number>
::    *  
::    *  The starting application (like Timer) can receive
::    *  the values simply by calling:
::    *  
::    *    Call <Filename>.BAT
::    *  
::    *  Example:
::    *  
::    *    Rem vvvvvv "Filename.bat" 26.01.2008 20:33:58 vvvvvv
::    *    Set GTLJ_Function=1
::    *    Set GTLJ_TimeDiff=33
::    *    Rem ^^^^^^ "Filename.bat" ^^^^^^
::    *
::    ****************************************************
%HlpExit%
::
Set GetTimeLeap_Job_File=%Temp%\GetTimeLeap_Job.cmd

:: echo on
Prompt $G
Title TimeLeap
Set GTLJ_TimeExit=10
Set GTLJ_Syn_Para_CntMax=6

Set GTLJ_Para1=%~1
:: Echo.   GTLJ_Para1: "%GTLJ_Para1%"
Call :GTLJ_Filename "%GTLJ_Para1%"
Call :GTLJ_Echo "%GTLJ_Filename%"

Set GTLJ_Function=0
Set GTLJ_TimeDiff=0
Set /A GTLJ_TimeSleep= 1000

Call :GTLJ_FileBatWr "%GTLJ_Filename%"

:GetTimeLeap_1Statem
Set /A GTLJ_Function= 0
Set /A GTLJ_TimeCnt= 0
Set /A GTLJ_Syn_Para_Old= 0
Set /A GTLJ_Syn_Para_Cnt= 0

%Call_%GetDateTime
:: echo on
Set /A GTLJ_TokenTime= %Dat_TokenTime%

:: ===========================================
:GetTimeLeap_LoopStart
Title TimeLeap %Dat_Hour%:%Dat_Min%:%Dat_Sec%
Call :GetTimeLeap_Wait
If NOT EXIST "%GTLJ_Filename%" (
	Echo.   *** File ".. %GTLJ_Ext%" deleted: EXIT this job NOW
	Set GTLJ_Function=2
	Set GTLJ_TimeExit=0
	Goto GetTimeLeap_Exit
)

If %GTLJ_Function% EQU 0 (Goto GetTimeLeap_LoopStart)
:: ===========================================

If %GTLJ_Function% EQU 1 %Call_%GetDateTime
If %GTLJ_Function% EQU 1 (
	Set /A GTLJ_TimeDiff= %Dat_TokenTime% - %GTLJ_TokenTime%
)
If %GTLJ_Function% EQU 1 (
	Rem Echo.
	Rem Fct: 1 Diff: 12 s
	Rem Time-Leap:   
	rem Echo. . %GTLJ_Time% %GTLJ_TokenTime%/%Dat_TokenTime%  SYN: %GTLJ_Syn_Para_Act%  Fct: %GTLJ_Function% Diff: %GTLJ_TimeDiff% s                
	Echo. . %GTLJ_Time% %GTLJ_TokenTime%/%Dat_TokenTime%  SYN: %GTLJ_Syn_Para_Act%  Time-Leap:   %GTLJ_TimeDiff% s                
)
Call :GTLJ_FileBatWr "%GTLJ_Filename%"

Rem Set GTLJ_Function=
Set GTLJ_TimeCheck=
Set GTLJ_TimeCnt=
Rem Set GTLJ_TimeDiff=178
Rem Set GTLJ_TimeSleep=
Set GTLJ_TokenTime=
Set GTLJ_TokenTime10=
Set GTLJ_TokenTime2m=
Set GTLJ_TokenTime2p=
Set GTLJ_TokenTimeBuch=
Set GTLJ_TokenTimeChk=

Goto GetTimeLeap_1Statem

:GetTimeLeap_Exit
Title TimeLeap EXIT
Echo.
Echo.  Exit in %GTLJ_TimeExit% seconds
Sleep %GTLJ_TimeExit%
@%Call_%Call_Exit %0
Rem ^^^^^^^^^^ Ende %0 ^^^^^^^^^^
@EXIT /B 0


==================================================
:GetTimeLeap_Wait
Sleep -m  %GTLJ_TimeSleep%
Set    GTLJ_Time=%Time%
Set    GTLJ_Time=%GTLJ_Time:~0,8%
Set /A GTLJ_TokenTime= GTLJ_TokenTime + 1
Set /A GTLJ_TimeCnt= %GTLJ_TimeCnt% + 1
Set /A GTLJ_TokenTime10= %GTLJ_TokenTime% / 10 * 10

Set /A GTLJ_TokenTimeChk= %GTLJ_TokenTimeChk% + 1
Rem QEcho "%GTLJ_TokenTime% %GTLJ_TokenTime10%/ "
If %GTLJ_TokenTimeChk% EQU 0 Set GTLJ_TokenTimeBuch=-
If %GTLJ_TokenTimeChk% EQU 1 Set GTLJ_TokenTimeBuch=^|
If %GTLJ_TokenTimeChk% EQU 2 Set GTLJ_TokenTimeBuch=/
If %GTLJ_TokenTimeChk% EQU 3 Set GTLJ_TokenTimeBuch=-
If %GTLJ_TokenTimeChk% EQU 4 (
	Set GTLJ_TokenTimeBuch=\
	Set GTLJ_TokenTimeChk=0
)
Rem QEcho "%GTLJ_TokenTimeChk% %GTLJ_TokenTimeBuch%" CR
QEcho " %GTLJ_TokenTimeBuch%" CR

If %GTLJ_TimeCnt% LEQ 7 (Goto GetTimeLeap_SubExit)

Rem --- after Midnight
If %GTLJ_TokenTime% GEQ 86400 (
	%Call_%GetDateTime
	Set /A GTLJ_TokenTime= %Dat_TokenTime%
	Set /A GTLJ_TimeCnt= 0
	Goto GetTimeLeap_SubExit
)

Rem --- do only every xx sec
If %GTLJ_TokenTime% EQU %GTLJ_TokenTime10% (
	Call :Sys_Check "%GTLJ_DevPathNam%.SYN"
	Set GTLJ_TokenTime10_now=1
	%Call_%GetDateTime
) Else (
	Set GTLJ_TokenTime10_now=0
)
Set /A GTLJ_TokenTime2m= %GTLJ_TokenTime% - 2
Set /A GTLJ_TokenTime2p= %GTLJ_TokenTime% + 2

Set /A GTLJ_TimeCheck= 0

If %GTLJ_TokenTime% EQU %GTLJ_TokenTime10% (
If %Dat_TokenTime% GEQ %GTLJ_TokenTime2m% (
If %Dat_TokenTime% LEQ %GTLJ_TokenTime2p% (
If %Dat_TokenTime% NEQ %GTLJ_TokenTime% (
	Set /A GTLJ_TimeCheck= 1
)

QEcho " . %GTLJ_Time% %GTLJ_TokenTime%/%Dat_TokenTime%  SYN: %GTLJ_Syn_Para_Act%  Sleep const: %GTLJ_TimeSleep% msec                  " CR
) Else (
	Set /A GTLJ_Function= 1
)
) Else (
	Set /A GTLJ_Function= 1
)
)

If %GTLJ_TimeCheck% GTR 0 (
	Set /A GTLJ_TimeDiff= %Dat_TokenTime% - %GTLJ_TokenTime%
	Set /A GTLJ_TimeCnt= 0
)
Rem ----- Fehler: Error: %GTLJ_Function% Diff: %GTLJ_TimeDiff%
If %GTLJ_Function% GTR 0 (
	Goto GetTimeLeap_SubExit
)
Rem -----------------------------------------------------
If %GTLJ_TimeCheck% GTR 0 (
	Set /A GTLJ_TimeDiffMult= -1*%GTLJ_TimeDiff% *  10
)
If %GTLJ_TimeCheck% GTR 0 (
	Rem Echo.  ******************************************************
	QEcho " . %GTLJ_Time% %GTLJ_TokenTime%/%Dat_TokenTime%  SYN: %GTLJ_Syn_Para_Act%  adjust Sleep %GTLJ_TimeSleep% + %GTLJ_TimeDiffMult% msec        " CR
	Rem Echo.  ******************************************************
	Rem Echo.
)
If %GTLJ_TimeCheck% EQU 0 (Goto GetTimeLeap_SubExit)

Set /A GTLJ_TokenTime= %Dat_TokenTime%
Set /A GTLJ_TimeSleep= %GTLJ_TimeSleep% + 1*(%GTLJ_TimeDiffMult%)

:GetTimeLeap_SubExit
Exit /B 0

=========================================================================

:Sys_Check

If NOT EXIST "%~1" (
	Set GTLJ_Syn_Para_Act=---
	Goto Sys_CheckExit
)

Rem %~t1 = Time   %~z1 = Length
:: %Call_%GetDateTime %~t1
:: Set GTLJ_Syn_Para_Act=%Dat_TokenTime%
Set GTLJ_Syn_Para_Act=%~z1
:: Echo.    SYN act: %GTLJ_Syn_Para_Act%   old: %GTLJ_Syn_Para_Old%                       
If %GTLJ_Syn_Para_Old% EQU 0 (
	Set GTLJ_Syn_Para_Old=%GTLJ_Syn_Para_Act%
) Else (

	Rem --- file was updated: ok
	If %GTLJ_Syn_Para_Act% NEQ %GTLJ_Syn_Para_Old% (
		Set /A GTLJ_Syn_Para_Cnt= 0
		Set /A GTLJ_Syn_Para_Old= %GTLJ_Syn_Para_Act%

	) Else (
		Set /A GTLJ_Syn_Para_Cnt= %GTLJ_Syn_Para_Cnt% + 1
		Echo.   *** No update SYN-file   Cnt: %GTLJ_Syn_Para_Cnt% max: %GTLJ_Syn_Para_CntMax%                                    
		If %GTLJ_Syn_Para_Cnt% GEQ %GTLJ_Syn_Para_CntMax% (
			Set GTLJ_Function=2
			Rem --- delete this and all other instances connected to the same file
			Del "%~1"
			Del "%GTLJ_Filename%"
			Goto GetTimeLeap_Exit
		)
	)
)

:Sys_CheckExit
Exit /B 0

=========================================================================

:GTLJ_Filename
Rem --- Filename:  "%~1"
Rem --- eXtension: "%~x1"
Set GTLJ_Ext=%~x1
If "%GTLJ_Ext%" EQU "" (Set GTLJ_Ext=.Bat)

Rem --- Device Path Name: "%~dpn1"
Set GTLJ_DevPathNam=%~dpn1
If "%GTLJ_DevPathNam%" EQU "" (
Set GTLJ_DevPathNam=%Temp%\GetTimeLeap_Data
Set GTLJ_Filename=
)
If "%GTLJ_Filename%" EQU "" (
Set GTLJ_Filename=%GTLJ_DevPathNam%%GTLJ_Ext%
)
:: Echo.    GTLJ_Filename:    %GTLJ_Filename%
:: Echo.    GTLJ_DevPathNam:  %GTLJ_DevPathNam%
Exit /B 0


=====================================================================
:GTLJ_FileBatWr

:: echo. Write to: "%~nx1"
(
Echo Rem vvvvvv "%~nx1" %Date% %Time% vvvvvv
Echo Set GTLJ_Function=%GTLJ_Function%
Echo Set GTLJ_TimeDiff=%GTLJ_TimeDiff%
Echo Rem ^^^^^^^^^^^^ "%~nx1" ^^^^^^^^^^^^
) >"%~1"

Exit /B 0


=====================================================================
:GTLJ_Echo

Echo TimeLeap  V 0.16
Echo Path: "%~dp1"
Echo File: "%~nx1"  [.bat]+.syn

Exit /B 0

:: ***CutEnde*** GetTimeLeap.cmd


:: ***CutAnfg*** GetDateTime.cmd

:: 
@Goto GetDateTime

cls&Echo Off
Echo.&Echo.  Date
set Dat_aaDate=05-7-08&Call :GetDateTime !Dat_aaDate!&echo !Dat_aaDate!    Datum+Zeit: !Dat_DateStr! !Dat_HHMMSS!
set Dat_aaDate=05-07-08&Call :GetDateTime !Dat_aaDate!&echo !Dat_aaDate!    Datum+Zeit: !Dat_DateStr! !Dat_HHMMSS!
set Dat_aaDate=2005-7-08&Call :GetDateTime !Dat_aaDate!&echo !Dat_aaDate!    Datum+Zeit: !Dat_DateStr! !Dat_HHMMSS!
set Dat_aaDate=2005-07-08&Call :GetDateTime !Dat_aaDate!&echo !Dat_aaDate!    Datum+Zeit: !Dat_DateStr! !Dat_HHMMSS!
set Dat_aaDate=05-7-8&Call :GetDateTime !Dat_aaDate!&echo !Dat_aaDate!    Datum+Zeit: !Dat_DateStr! !Dat_HHMMSS!
set Dat_aaDate=05-07-8&Call :GetDateTime !Dat_aaDate!&echo !Dat_aaDate!    Datum+Zeit: !Dat_DateStr! !Dat_HHMMSS!
set Dat_aaDate=2005-7-8&Call :GetDateTime !Dat_aaDate!&echo !Dat_aaDate!    Datum+Zeit: !Dat_DateStr! !Dat_HHMMSS!
set Dat_aaDate=2005-07-8&Call :GetDateTime !Dat_aaDate!&echo !Dat_aaDate!    Datum+Zeit: !Dat_DateStr! !Dat_HHMMSS!

Echo.&Echo.  Time
set Dat_aaTime=1:5:7&Call :GetDateTime !Dat_aaTime!&echo !Dat_aaTime!    Datum+Zeit: !Dat_DateStr! !Dat_HHMMSS!
set Dat_aaTime=1:5:07&Call :GetDateTime !Dat_aaTime!&echo !Dat_aaTime!    Datum+Zeit: !Dat_DateStr! !Dat_HHMMSS!
set Dat_aaTime=1:05:07&Call :GetDateTime !Dat_aaTime!&echo !Dat_aaTime!    Datum+Zeit: !Dat_DateStr! !Dat_HHMMSS!
set Dat_aaTime=01:05:07&Call :GetDateTime !Dat_aaTime!&echo !Dat_aaTime!    Datum+Zeit: !Dat_DateStr! !Dat_HHMMSS!

Echo.&Echo.  Date/Time  Time/Date
set Dat_aaDate05-7-8=&set Dat_aaTime=1:5:7&Call :GetDateTime !Dat_aaDate! !Dat_aaTime!&echo !Dat_aaDate! !Dat_aaTime!    Datum+Zeit: !Dat_DateStr! !Dat_HHMMSS!
set Dat_aaDate05-7-8=&set Dat_aaTime=1:5:7&Call :GetDateTime !Dat_aaTime! !Dat_aaDate!&echo !Dat_aaDate! !Dat_aaTime!    Datum+Zeit: !Dat_DateStr! !Dat_HHMMSS!
Exit /B 0

:: *******************************************************************
:GetDateTime
Rem vvvvvvvvvv Anfg %0 vvvvvvvvvv
@If "%Call_%" EQU "" (Set Call_=Call )
@%Call_%Call_Init %0
@%Call_%Call_Help "%~1"
:: echo on

%EchoLabel% %0 Para: "%~1" "%~2"
::
::    ****************************************************
::    *  Autor:    Kalle Koseck
::    *  Datum:    2006-01-10
::    *  Revision: 2007-05-28
::    *  Revision: 2007-11-15
::    *  File:     GetDateTime.cmd
::    *  License:  GPL / GNU General Public License
::    *    
::    *  Input:
::    *    
%Hlp% *    Date format: DD.MM.YYYY | DD.MM.YY | YYYY-MM-DD | YY-MM-DD
%Hlp% *    Time format: HH:MM | HH:MM:SS | HH:MM:SS,000 | HH:MM:SS.000
%Hlp% *    
%Hlp% *    String: Date OR Time
%Hlp% *    String: Datum ODER Zeit
%Hlp% *    Para 1: "%~1"
%Hlp% *    
::    *    ist der String leer (nicht angegeben),
::    *    so wird die aktuelle Zeit genommen
::    *    ist hier die ZEIT angegeben, so wird als default
::    *    das aktuelle Datum genommen
::    *    
::    *    If the string is empty (or not given)
::    *    the actual time is taken.
::    *    If the parameter is set, the
::    *    actual Time or Date is assumed as default
::    *
%Hlp% *    String: Time OR Date
::    *    String: Zeit ODER Datum
%Hlp% *    Para 2: "%~2"
::    *    
::    *    ist der String leer (nicht angegeben),
::    *    so wird die aktuelle Zeit genommen
::    *    
::    *    If the string is empty (or not given)
::    *    the actual Date OR Time is taken.
::    *    
::    *    -------------------------------------------------------------
::    *    Bemerkung:
::    *    Es ist erlaubt Datum UND / ODER Zeit als ersten
::    *    oder zweiten Parameter anzugeben.
::    *    Es darf auch nur das Datum oder nur die Zeit dekodiert
::    *    werden.
::    *    
::    *    Remark:
::    *    Date AND / OR Time can be given as first or second
::    *    parameter.
::    *    Allowed: set one parameter: only Date or only Time
::    *    -------------------------------------------------------------
::    *    
::    *  there are 2 different date formats:
::    *  and maybe more ...
::    *  
::    *  0123456789.123
::    *  Di 10.01.2006
::    *  10.01.2006
::    *  1.6.98
::    *  
::    *  0123456789.123
::    *  2008-07-05
::    *  2008-07-5
::    *  2008-7-05
::    *  2008-7-5
::    *  08-7-5 ...
::    *  
::    *  Time formats:
::    *  0123456789.123
::    *  01:22:03
::    *  1:22:03
::    *  
::    *  
::    ****************************************************
%HlpExit%
::

Set GetDateTime_Prog=%0
Set GetDateTime_ParAll=%*
Set Date=
Set Time=

Set Dat_Year=
Set Dat_Month=
Set Dat_Day=

Set Dat_Hour=
Set Dat_Min=
Set Dat_Sec=
Set Dat_Sec0=

Set Dat_Var=
Set Dat_VarCnt=0
:: Echo.  Para: "%~1" "%~2"
:GetDateTime_DatVarStart
Rem --- :GetDateTime_DatVarStart
Set Dat_Var=%~1
Shift
:GetDateTime_DatVarStartA
Rem --- :GetDateTime_DatVarStartA
Set /A Dat_VarCnt= %Dat_VarCnt% + 1
If "%Dat_Var%" EQU "" Goto GetDateTime_DatVarNoVar

:: %EchoLabel%  Dat_Var     %DatVar%
Rem --- Time HH:MM:SS  "%Dat_Var%"
If "%Dat_Min%" NEQ "" Goto GetDateTime_NoTime

Rem --- HH:MM:SS,00 | HH:MM:SS.00   "%Dat_Var%"
For /F "delims=: tokens=1-3" %%A IN ("%Dat_Var%") do (
	Set Dat_Hour=%%A
	Set Dat_Min=%%B
	Set Dat_Sec=%%C
)
Rem --- "%Dat_Hour%" "%Dat_Min%" "%Dat_Sec%" 

If "%Dat_Min%" EQU "" Goto GetDateTime_NoTime
If "%Dat_Sec%" EQU "" Set Dat_Sec=00

Rem --- seconds: z.B. 23,45 with comma   "%Dat_Sec%"
For /F "delims=, tokens=1-3" %%A IN ("%Dat_Sec%") do (
	Set Dat_Sec=%%A
	Set Dat_Sec0=%%B
)
Rem --- seconds: z.B. 23.45 with point   "%Dat_Sec%"
If "%Dat_Sec0%" EQU "" (
For /F "delims=. tokens=1-3" %%A IN ("%Dat_Sec%") do (
	Set Dat_Sec=%%A
	Set Dat_Sec0=%%B
) )
If "%Dat_Sec0%" EQU "" (
	Set Dat_Sec0=00
	Set /A Dat_iSec0=0
)
Rem --- did we find a time ?
%EchoLabel% End Time   "%Dat_Hour%" "%Dat_Min%" "%Dat_Sec%" "%Dat_Sec0%"
If "%Dat_Hour%" NEQ "" (
If "%Dat_Min%"  NEQ "" (
	Goto GetDateTime_DatVarStart
) )
Rem ================================================================================
:GetDateTime_NoTime
%EchoLabel% :GetDateTime_NoTime
:: pause
::----------------------------------------------------------------
Rem --- DD.MM.YYYY or YYYY-MM-DD: "%Dat_Var%"
If "%Dat_Month%" NEQ "" Goto GetDateTime_NoDate

For /F "delims=. tokens=1-3" %%A IN ("%Dat_Var%") do (
	Set Dat_Year=%%C
	Set Dat_Month=%%B
	Set Dat_Day=%%A
)
Rem --- "%Dat_Year%" "%Dat_Month%" "%Dat_Day%" 

Rem --- YYYY-MM-DD
If "%Dat_Month%" EQU "" (
	For /F "delims=- tokens=1-3" %%A IN ("%Dat_Var%") do (
		Set Dat_Year=%%A
		Set Dat_Month=%%B
		Set Dat_Day=%%C
	)
)
Rem --- "%Dat_Year%" "%Dat_Month%" "%Dat_Day%" 
:: If "%Dat_Month%" EQU "" Goto GetDateTime_NoDate
:: -------------------------------------------
Rem --- Dat_Year: "Mo 2007-..." / "%Dat_Year%"
For /F "tokens=1-2" %%A IN ("%Dat_Year%") do (
	Set Dat_DayName=%%A
	Set Dat_Year=%%B
)
Rem --- "%Dat_Year%" "%Dat_DayName%" 
Rem --- no name of day, was: "2007-..."
If "%Dat_Year%" EQU "" (
	Set Dat_Year=%Dat_DayName%
	Set Dat_DayName=-
)
:GetDateTime_NoDate
Rem --- :GetDateTime_NoDate ====================================================
Rem --- End Date: "%Dat_Year%" "%Dat_Month%" "%Dat_Day%" 
:: pause
Goto GetDateTime_DatVarStart
================================================================================

:GetDateTime_DatVarNoVar
Rem --- :GetDateTime_DatVarNoVar
If "%Dat_VarCnt%" GEQ "6" (
(
	Echo.  *
	Echo.  **************************************************************
	Echo.  *
	Echo.  *  ***Fatal***: Routine: %GetDateTime_Prog%
	Echo.  *  Parameter: %GetDateTime_ParAll%
	Echo.  *  %Dat_VarCnt% Versuche, aber Date / Time nicht aufgeloest.
	Echo.  *
	Echo.  **************************************************************
	Echo.  *
	) >%OutCon%
	%Color_CMD_Error%
	Pause *** Fataler Fehler ***
	Goto :GetDateTime_Fehler
)

If "%Dat_Min%" EQU "" (
	Set Dat_Var=%Time%
	Rem --- Pause
	Goto GetDateTime_DatVarStartA
)
If "%Dat_Month%" EQU "" (
	Set Dat_Var=%Date%
	Rem --- Pause
	Goto GetDateTime_DatVarStartA
)

If "%Dat_Min%" EQU "" (
(
	Echo.  *
	Echo.  **************************************************************
	Echo.  *
	Echo.  *  ***Fatal***: Routine: %0
	Echo.  *  Parameter: %GetDateTime_ParAll%
	Echo.  *  Das Zeit-Format wurde nicht erkannt: "%Time%"
	Echo.  *
	Echo.  **************************************************************
	Echo.  *
	) >%OutCon%
	%Color_CMD_Error%
	Pause *** Fataler Fehler ***
	Goto :GetDateTime_Fehler
)
If "%Dat_Month%" EQU "" (
	(
	Echo.  *
	Echo.  **************************************************************
	Echo.  *
	Echo.  *  ***Fatal***: Routine: %0
	Echo.  *  Parameter: %GetDateTime_ParAll%
	Echo.  *  Das Datum-Format wurde nicht erkannt: "%Date%"
	Echo.  *
	Echo.  **************************************************************
	Echo.  *
	) >%OutCon%
	%Color_CMD_Error%
	Pause *** Fataler Fehler ***
:GetDateTime_Fehler
Set Dat_Year=0
Set Dat_Month=0
Set Dat_Day=0
Set Dat_Hour=0
Set Dat_Min=0
Set Dat_Sec=0
Echo Unknown date/time: %Date%" "%Time%" > _GetDateTime_Unknown.txt
)
Set Date=
Set Time=
%EchoLabel% GetDateTimeFormat "%Dat_Year%" "%Dat_Month%" "%Dat_Day%" "%Dat_Hour%" "%Dat_Min%" "%Dat_Sec%" "%Dat_Sec0%" 
%Call_%GetDateTimeFormat

Set Dat_DateStr=%Dat_Year%-%Dat_Month%-%Dat_Day%

:: 
:GetDateTime_Ende
%EchoLabel% GetDateTime_Ende
@%Call_%Call_Exit %GetDateTime_Prog%
Rem ^^^^^^^^^^ Ende %GetDateTime_Prog% "%Dat_iYear%" "%Dat_iMonth%" "%Dat_iDay%" "%Dat_iHour%" "%Dat_iMin%" "%Dat_iSec%" ^^^^^^^^^^
@EXIT /B 0

:: ***CutEnde*** GetDateTime.cmd


:: ***CutAnfg*** Call_Init
::
:: 
::    *****************************************************************
::    *  Autor:    Kalle Koseck
::    *  Datum:    2007-06-02
::    *  Revised:  2007-11-01
::    *            2008-07-13  also unknown Paras with "/" ok
::    *  File:     Call_Init.Cmd
::    *  License:  GPL / GNU General Public License
::    *
::    *  Call:
::    *
::    *    %Call_%Call_Init "<calling-subroutine>"
::    *
::    *  Known Call_Init_Cmd_Parameter:
::    *  (these Paras can be used without "/")
::    *
::    *    Init On Off Echo Trace
::    *    also this is ok: /Init /On /Off /Echo /Trace
::    *    
::    *  Unknown Parameters:
::    *    
::    *    use with "/" like "/Test"
::    *    a var with "Echo_Seen_Test" is generated and set to 1
::    *
::    *****************************************************************
::
:Call_Init
:: Exit /B 0
:: 
:: 
@If /I "%~1" EQU "/INIT" Set Call_Init_Quick=
@If "%Call_Init_Quick%" EQU "Q" Goto Call_Init_ExitQ

:Call_Init_Init
@Echo Off
Set Call_Init_Quick=
If "%Echo_Seen_Init%" EQU "" Call :Call_Init_Default
Set Echo_Make=Off
Rem Echo.  ********************************************** Call_Init CallLevel Anfg: %CallLevel%

@Set Call_Init_Ec=@Rem --- 

%Call_Init_Ec% Echo   Call_Init  0000 --- und START "%~1" "%~2" "%~3" "%~4" "%~5" "%~6"
If "%Call_%" EQU "" Set Call_=Call 
:: Echo %0 SubrCall_NO "%SubrCall_NO%"
:: Set @At=&Call :Call_Init_Echo On #1#&Echo   Debug = %Debug%
Rem vvvvvvvvvv Anfg %0 %* vvvvvvvvvv
If "%Echo_Seen_Init%" EQU "" Set Echo_Seen_Init=0
Set Echo_Seen_InitDone=
If /I "%~1" EQU "/TEST" Goto Call_Init_Exit

Set Call_Init_Cmd_ThisProg=%~0
Set Call_Init_Cmd_CalledFrom=%~1

Set Call_Init_Cmd_Kdo=StartPara:
Call :Set_Debug Debug01 "%~1"
Call :Set_Debug Debug02 "%~2"
Call :Set_Debug Debug03 "%~3"
Call :Set_Debug Debug04 "%~4"
Call :Set_Debug Debug05 "%~5"
Call :Set_Debug Debug06 "%~6"
Call :Set_Debug Debug07 "%~7"
Call :Set_Debug Debug08 "%~8"
Call :Set_Debug Debug09 "%~9"

%Call_Init_Ec% Echo.Set Debug0x&Set Debug0 2>NUL
::::::::::::::::::::
%Call_Init_Ec% Echo   Call_Init  0002

:: Goto Call_Init_NoTime
Rem --- Time needed by routine: remember start-time
If "%SubrCall_NO%" EQU "" Set SubrCall_NO=1
If "%SubrCall_NO%" EQU "1" Goto Call_Init_NoTime

Rem If "%Echo_Seen_Init%" NEQ "!Echo_Seen_Init!"
If "%Echo_Seen_Init%" NEQ "!Echo_Seen_Init!" (
	Set SubrCall_NO=1
	Echo 
	Echo   ************************************************************************************
	Echo   ***  "Verzoegerte Befehlsausfuehrung" nicht aktiviert; Zeitmessung abgeschaltet  ***
	Echo   ***  "Delayed Expansion" is disabled; Measurement of routine times are disabled  ***
	Echo   ************************************************************************************
	Echo 
	ping -n 5 127.0.0.1 1>NUL 2>NUL 
	Goto Call_Init_NoTime
)

If "%Call_Init_Cmd_Para%" NEQ "" (
	@%EchoLabel% vvvvvvvvvv "%1" %* vvvvvvvvvv
	Set Call_Init_ProgName=%Call_Init_Cmd_Para%
	%Call_%GetTokenTime %0
	@Rem --- 
	%Call_Init_Ec% Echo   Call_Init  0002a  SubrCall_%Call_Init_Cmd_Para%_TimeCnt  !SubrCall_%Call_Init_Cmd_Para%_TimeCnt!
	set /A kk= +1
	Set /A SubrCall_%Call_Init_Cmd_Para%_TimeCnt= !SubrCall_%Call_Init_Cmd_Para%_TimeCnt! +1
	@Rem --- 
	%Call_Init_Ec% Echo   Call_Init  0002b  SubrCall_%Call_Init_Cmd_Para%_TimeCnt  !SubrCall_%Call_Init_Cmd_Para%_TimeCnt!
	If "!SubrCall_%Call_Init_Cmd_Para%_TimeStrt!" NEQ "" (
		
		Echo 
		Echo *************************************************************************
		Echo 
		Set SubrCall 2>NUL
		Echo 
		Echo   Call_Init: "Call_Exit" not called or reentrant call: %Call_Init_Cmd_Para%
		Echo >>"%EchoCON%"
		Pause
		Set SubrCall_NO=1
	)
)

%Call_Init_Ec% Echo   Call_Init Dat_TokenTime0 "%Dat_TokenTime0%"
If "%Call_Init_Cmd_Para%" NEQ "" (
	Set /A SubrCall_%Call_Init_Cmd_Para%_TimeStrt= !Dat_TokenTime0!
	@Rem --- 
	%Call_Init_Ec% Echo   Call_Init  0002c  SubrCall_%Call_Init_Cmd_Para%_TimeStrt  !SubrCall_%Call_Init_Cmd_Para%_TimeStrt!
	Shift
)
:Call_Init_NoTime
Rem --- Lbl --- :Call_Init_NoTime
Goto Call_Init_Cmd_GetNextPara_NoShift
================================================================

:: --- shit: was not called with init-para
If "%Echo_Seen_Trace%" EQU "" Call :Call_Init_Subr DOIT

Set Call_Init_Cmd_CalledFrom=%Call_Init_Cmd_Para%
Shift
::
%Call_Init_Ec% Echo   Call_Init  0003
Goto Call_Init_Cmd_GetNextPara

Rem ==================================================================
:Call_Init_Cmd_ParaStart
Rem ==================================================================
Set Call_Init_Cmd_Para=%Debug01%
If "%Call_Init_Cmd_Para%" EQU "" (
	%Call_Init_Ec% Echo   Call_Init  0004a  Call_Init_Cmd_Para leer
	Goto Call_Init_Ende
)

Rem --- remove first char if "/" or ":"
Set Call_Init_Cmd_ParaSlash=0
rem --- If "%Call_Init_Cmd_Para:~0,1%" EQU "/" 
If "%Call_Init_Cmd_Para:~0,1%" NEQ "/" Goto Call_Init_UserPara

Rem --- If "%Call_Init_Cmd_Para:~0,1%" EQU ":" Set Call_Init_Cmd_Para=%Call_Init_Cmd_Para:~1%
	Set Call_Init_Cmd_Para=%Call_Init_Cmd_Para:~1%
	Set Call_Init_Cmd_ParaSlash=1
	If "%Call_Init_Cmd_Para:~0,1%" EQU ":" Set Call_Init_Cmd_Para=%Call_Init_Cmd_Para:~1%
	%Call_Init_Ec% Echo                   ===============  gesehen %Call_Init_Cmd_Kdo%    "%Call_Init_Cmd_Para%"

	%Call_Init_Ec% Echo   Call_Init  0004b --- INIT
	If /I "%Call_Init_Cmd_Para%" NEQ "INIT" Goto Call_Init_NoInit
	Call :Call_Init_Echo Off #2#
	%Call_Init_Ec% Echo                   =============== %Call_Init_Cmd_Kdo% === INIT ===
	Set Call_Init_Quick=Q
Set Init_Rem=Rem
	%Call_%Var_ClearAll "Echo_Seen_"
	%Call_%SubrCall_ClearAll
	rem --- Call :Call_Init_Subr DOIT
	Call :Call_Init_Subr DOIT
	Set Echo_Seen_Init=1
	Set Echo_Seen_InitDone=1
	Goto Call_Init_Cmd_GetNextPara
:Call_Init_NoInit
::
	%Call_Init_Ec% Echo   Call_Init  0005 --- OFF
	If /I "%Call_Init_Cmd_Para%" NEQ "OFF" Goto Call_Init_NoOff
	%Call_Init_Ec% Echo                   =============== %Call_Init_Cmd_Kdo% === OFF ===
	Set CallEchoOff=1
	%Call_Init_Ec% Echo   OFF CallEchoOff "%CallEchoOff%"
	Rem Call :Call_Init_Echo Off #3#
	Goto Call_Init_Cmd_GetNextPara
:Call_Init_NoOff
::
	%Call_Init_Ec% Echo   Call_Init  0006 --- ON
	If /I "%Call_Init_Cmd_Para%" NEQ "ON" Goto Call_Init_NoOn
	%Call_Init_Ec% Echo                   =============== %Call_Init_Cmd_Kdo% === ON ===
	Set Call_Init_Quick=
	Call :Call_Init_Subr
	Set CallEchoOff=0
	%Call_Init_Ec% Echo   ONa CallEchoOff "%CallEchoOff%"
	Call :Call_Init_Echo On #4#
	Goto Call_Init_Cmd_GetNextPara
:Call_Init_NoOn
::
	%Call_Init_Ec% Echo   Call_Init  0007 --- FILE
	Rem     should include: "on" and "trace"
	If /I "%Call_Init_Cmd_Para%" NEQ "FILE" Goto Call_Init_NoFile
	%Call_Init_Ec% Echo                   =============== %Call_Init_Cmd_Kdo% === FILE ===
	Set Call_Init_Quick=
	Set Echo_Seen_File=1
	Set Echo_FileDir=%Temp%
	Set Echo_FileName=Debug_Log.txt
	Set Echo_FilePath=%Echo_FileDir%\%Echo_FileName%
	Rem --- Option ON
	Call :Call_Init_Subr
	Set CallEchoOff=0
	Goto Call_Init_Trace
:Call_Init_NoFile
::
	%Call_Init_Ec% Echo   Call_Init  0008 --- TRACE
	If /I "%Call_Init_Cmd_Para%" NEQ "TRACE" Goto Call_Init_NoTrace
	:Call_Init_Trace
	Set Call_Init_Quick=
	Set CallLevel=0
	Set EchoLabel=%Call_%EchoLabel ::   
	Set EchoOn=Rem Echo On
	%Call_Init_Ec% Echo   Call_Init  0009
	Set EchoOff=Echo Off
	Set EchoDelay=0
	Set EchoCON=CON
	::
	%Call_Init_Ec% Echo   Call_Init  0010
	%Call_Init_Ec% Echo                   =============== %Call_Init_Cmd_Kdo% === TRACE ===
	Set Call_Init_Quick=
	Set Echo_Seen_Trace=1
	%Call_Init_Ec% Echo   Call_Init  0011
	%Call_Init_Ec% Echo   TRACE CallEchoOff "%CallEchoOff%"
	Set EchoOn=Echo Off
	Set EchoOff=Echo Off
	%Call_Init_Ec% Echo   Call_Init  0012
	Goto Call_Init_Cmd_GetNextPara
:Call_Init_NoTrace

	::                                                               === ECHO ===
	%Call_Init_Ec% Echo   Call_Init  0013 --- ECHO "%Debug02%"
	If /I "%Call_Init_Cmd_Para%" NEQ "ECHO" Goto Call_Init_NoEcho
	Set Call_Init_Quick=
	Set CallLevel=0
	Set EchoLabel=%Call_%EchoLabel ::   
	Set EchoOn=Rem Echo On
	Set EchoOff=Echo Off
	Set EchoDelay=0
	Set EchoCON=CON
	Rem --- Echo and EchoLevel=how deep sub-calls should be echoed
	Set Echo_Seen_Echo=1
	Set Echo_Seen_EchoLevel=1
	Set EchoOn=Echo On
	Set EchoOff=Echo On
	If "%CallEchoOff%" EQU "" Set CallEchoOff=0& %Call_Init_Ec% Echo   ECHO CallEchoOff "%CallEchoOff%"

	Rem --- EchoLevel given?
	If "%Debug02%" EQU "" Goto Call_Init_EchoExit
	Rem --- normally: only level 1 is echoed, which is the main level
	If /I "%Debug02:~0,1%" NEQ "/" (
		Set Echo_Seen_EchoLevel=%Debug02%
		Call :Call_Init_Shift
	)
:Call_Init_EchoExit

	%Call_Init_Ec% Echo                   =============== %Call_Init_Cmd_Kdo% === ECHO %Echo_Seen_EchoLevel% ===
	Goto Call_Init_Cmd_GetNextPara
:Call_Init_NoEcho

:Call_Init_UserPara
	If "%Call_Init_Cmd_ParaSlash%" EQU "0" Goto Call_Init_Cmd_GetNextPara
	Rem --- till now: unknown command
	Rem     create user-defined parameter:
	%Call_Init_Ec% Echo                   =============== %Call_Init_Cmd_Kdo% === USER-DEFINED PARAMETER "%Call_Init_Cmd_Para%" ===
	Set Call_Init_Cmd_Para1=1
	Rem --- is a value for the parameter given?
	If "%Debug02%" EQU "" Goto Call_Init_UserDefParaExit
	If /I "%Debug02:~0,1%" NEQ "/" (
		Set Call_Init_Cmd_Para1=%Debug02%
		Call :Call_Init_Shift
	)

:Call_Init_UserDefParaExit
Rem --- If "%Call_Init_Cmd_Para:~0,1%" EQU "/" 
Set Echo_Seen_%Call_Init_Cmd_Para%=%Call_Init_Cmd_Para1%
:: 
%Call_Init_Ec% Echo   Call_Init  0014
Goto Call_Init_Cmd_GetNextPara

==================================================================

%Call_Init_Ec% Echo   Call_Init  0015
:: set call & set echo
::  :Call_Init_Exit
::
If "%Call_%" EQU "" (
	Call :Call_Init_Subr
	Echo 
	Echo   Bitte VORHER aufrufen / Please call BEFORE:
	Echo 
	Echo     "Call Call_Init"
	Echo 
	Pause
)
::  ---------------------------------------------------------------
:Call_Init_Cmd_GetNextPara
	Call :Call_Init_Shift
::
:Call_Init_Cmd_GetNextPara_NoShift
	%Call_Init_Ec% Echo   Call_Init  0016  :Call_Init_Cmd_GetNextPara(NoShift) "%Debug01%"
	Set Call_Init_Cmd_Para=%Debug01%
	If "%Call_Init_Cmd_Para%" EQU "" Goto Call_Init_ParaEmpty

	Rem --- non blank parameter on stack - start or debug
	Goto Call_Init_Cmd_ParaStart

:Call_Init_ParaEmpty
Rem --- :Call_Init_ParaEmpty

Rem --- no further parameters to be processed - end reached
If /I "%Call_Init_Cmd_Kdo%" EQU "DebugPara:" (
	%Call_Init_Ec% Echo   Call_Init  0017
	Goto Call_Init_Cmd_DebugNo
)

:Call_Init_Fill_Debug
Rem --- Command line empty: check Debug-variable.
%Call_Init_Ec% Echo   Call_Init  0018 --- Debug = "%Debug%"
If "%Echo_Seen_Init%" EQU "0" Goto Call_Init_Cmd_DebugNo
Set Call_Init_Cmd_Kdo=DebugPara:
:: ---------------------------------------------
If %Echo_Seen_Init% LSS 2 (
If "%Debug%" NEQ "" (
	For /F "Tokens=1-9 Delims= " %%a In ("%Debug%") Do Set Debug01=%%a&Set Debug02=%%b&Set Debug03=%%c&Set Debug04=%%d&Set Debug05=%%e&Set Debug06=%%f&Set Debug07=%%g&Set Debug08=%%h&Set Debug09=%%i&Set Echo_Seen_Init=2
) )

	%Call_Init_Ec% Echo   Call_Init  0019 "%Debug01%" "%Debug02%" "%Debug03%" "%Debug04%" "%Debug05%"
	Goto Call_Init_Cmd_ParaStart

======================================================================

:Call_Init_Cmd_DebugNo
:Call_Init_Ende
%Call_Init_Ec% Echo   Call_Init  0025
:: @Echo :Call_Init_Ende
::
%Call_Init_Ec% Echo   Call_Init  0026
If "%CallEchoOff%" EQU "" Call :Call_Init_Subr N
:: --------------------------------------------------------------------
Rem --- CallLevel: %CallLevel%

%Call_Init_Ec% Echo   Call_Init  0027
Rem --- Sub %Call_Init_Cmd_ThisProg%   Para=%Call_Init_Cmd_Para%   CallLevel: %CallLevel%
::%Call_Init_Ec% Echo    If     %CallLevel% GEQ 0 Set /A CallLevel= %CallLevel% + 1
If %CallLevel% GEQ 0 If "%Echo_Seen_InitDone%" NEQ "1" Set /A CallLevel= %CallLevel% + 1
%Call_Init_Ec% Echo   Call_Init  0028
:: If     %CallLevel%    EQU  -1  (
	If /I "%CallEchoOff%" EQU "0" (@Call :Call_Init_Echo On #5#) Else (@Call :Call_Init_Echo Off #6#)
	%Call_Init_Ec% Echo   EXEC CallEchoOff "%CallEchoOff%"
:: )
%Call_Init_Ec% Echo   Call_Init  0029
Rem If %CallLevel% EQU 1 
If %CallLevel% EQU 1 (
	If "%CallEchoOff%" EQU "1" Call :Call_Init_Echo Off #7#
)
%Call_Init_Ec% Echo   Call_Init  0030
:: --- wenn noch unbekannte Call_Init_Cmd_Parameter uebrig sind: anzeigen
@Rem If "%Call_Init_Cmd_Para%" NEQ "" (
	@Rem If "%Call_Init_Cmd_ThisProg:~0,1%" NEQ "/" (
	@Rem %EchoLabel% %Call_Init_Cmd_ThisProg%  ??? %Call_Init_Cmd_Kdo% = "%Call_Init_Cmd_Para%" ??? ) )
%Call_Init_Ec% Echo   Call_Init  0031
:: %Call_Init_Ec% Echo   Call_Init  CallLevel Ende: %CallLevel%
%Call_Init_Ec% Echo   Call_Init  0032
If "%Echo_Seen_Trace%" EQU "1" (
If "%Echo_Seen_InitDone%" NEQ "1" (
If "%Call_Init_Cmd_CalledFrom%" NEQ "" (
		%EchoLabel% vvvvvvvvvv %Call_Init_Cmd_CalledFrom% vvvvvvvvvv
) ) )

%Call_Init_Ec% Echo   Call_Init  0033
:: Echo   %Call_Init_Cmd_ThisProg%  CallLevel %CallLevel%
:: --- Echo all lines in main prog
::     Level 3 means: first call level
Set /A CallLevelOn=%Echo_Seen_EchoLevel% + 2
If %Echo_Seen_Echo% EQU 1 (
	If %Echo_Seen_Init% GEQ 1 Call :Call_Init_Echo On #8#
	If %CallLevel% GEQ %CallLevelOn% Call :Call_Init_Echo Off #9#
)

:Call_Init_Exit
If "%CallEchoOff%" EQU "1" (Set Echo_Make=Off) Else (Set Echo_Make=On)
%Call_Init_Ec% Echo.  ****************************** vvvvv Call_Init Echo: "%CallEchoOff%"="%Echo_Make%"  Level: %CallLevel%
%Call_Init_Ec% Echo   Call_Init  0034 --- und EXIT
Rem ^^^^^^^^^^ Ende %Call_Init_Cmd_CalledFrom% ^^^^^^^^^^


:Call_Init_ExitQ
@Echo %Echo_Make%
:: Echo.  Call_Init_Quick = "%Call_Init_Quick%"  Init = "%Echo_Seen_Init%"
@EXIT /B 0

===========================================================================
*** Subroutinen ***

:Call_Init_Subr

Rem vvvvvvvvvv %0 vvvvvvvvvv
::
If /I "%~1" EQU "DOIT" Goto Call_Init_Subr_DOIT

If "%EchoLabel%" NEQ "" Goto Call_Init_Subr_Exit

:Call_Init_Subr_DOIT
	%Call_Init_Ec% Echo  :Call_Init_Subr_DOIT
	Set Echo_Seen_Trace=0
	Set  Echo_Seen_Echo=0
	Set  Echo_Seen_EchoLevel=0
	Set  Echo_Seen_File=0
	Set  Echo_FileDir=
	Set Echo_FileName=
	Set Echo_FilePath=%Echo_FileDir%\%Echo_FileName%
	Set      EchoLabel=Rem   
	Set        EchoCON=CON
	Set        EchoNUL=NUL
	Set      EchoDelay=0
	Set         Outcon=CON
	If "%~1" EQU "" (If "%Call_%" EQU "" (Set Call_=Call ) )
	Set   CallLevel=0
	Set CallEchoOff=1
	%Call_Init_Ec% %Call_Init_Ec% Echo   Call_Init_Subr_DOIT CallEchoOff "%CallEchoOff%"

	Set       Error=0


:Call_Init_Subr_Exit

Rem ^^^^^^^^^^ %0 ^^^^^^^^^^
:: @Set Call_Init_At=&@Set Call_Init_Rm=&@Set Call_Init_Ec=
@EXIT /B 0

===========================================================================

:Call_Init_Echo
::  @Echo %~1
Set Echo_Make=%~1
If /I "%~1" EQU "ON" (Set CallEchoOff=0) Else (Set CallEchoOff=1)
%Call_Init_Ec% Echo  :Call_Init  0051 _Echo  "%~1"="%CallEchoOff%"   %~2  Level %CallLevel%
@EXIT /B 0


===========================================================================

:Call_Init_Shift
Rem vvvvvvvvvv %0 vvvvvvvvvv

	Set Debug01=%Debug02%
	Set Debug02=%Debug03%
	Set Debug03=%Debug04%
	Set Debug04=%Debug05%
	Set Debug05=%Debug06%
	Set Debug06=%Debug07%
	Set Debug07=%Debug08%
	Set Debug08=%Debug09%
	Set Debug09=

%Call_Init_Ec% Echo  :Call_Init  0052 _Shift  Nx Para Debug01: "%Debug01%"

Rem ^^^^^^^^^^ %0 ^^^^^^^^^^
@EXIT /B 0
===========================================================================

:Call_Init_Default
Rem vvvvvvvvvv %0 vvvvvvvvvv

If "%EchoLabel%" EQU "" Set EchoLabel=Rem --- Label --- 
If "%EchoCON%"   EQU "" Set   EchoCON=CON
If "%EchoNUL%"   EQU "" Set   EchoNUL=NUL
If "%OutCon%"    EQU "" Set    Outcon=CON
If "%CallLevel%" EQU "" Set CallLevel=0
If "%Error%"     EQU "" Set     Error=0

If "%Echo_Seen_Init%"  EQU "" Set Echo_Seen_Init=0
If "%Echo_Seen_Echo%"  EQU "" Set Echo_Seen_Echo=0
If "%Echo_Seen_Trace%" EQU "" Set Echo_Seen_Trace=0
If "%Echo_Seen_File%"  EQU "" Set Echo_Seen_File=0

Rem ^^^^^^^^^^ %0 ^^^^^^^^^^
@EXIT /B 0
===========================================================================


:Set_Debug
Rem vvvvvvvvvv %0 vvvvvvvvvv

Set Slash=
If /I "%~2" EQU "INIT"   Set Slash=/
If /I "%~2" EQU "OFF"    Set Slash=/
If /I "%~2" EQU "ON"     Set Slash=/
If /I "%~2" EQU "TRACE"  Set Slash=/
If /I "%~2" EQU "ECHO"   Set Slash=/
If /I "%~2" EQU "FILE"   Set Slash=/

Set %~1=%Slash%%~2
Rem ^^^^^^^^^^ %0 ^^^^^^^^^^
@EXIT /B 0
===========================================================================


%Call_%EchoLabel -- NoExecute: nur die Referenz --

::
:: ***CutEnde*** Call_Init
::

:: ***CutAnfg*** Call_Exit.cmd

::
::    ****************************************************
::    *  Author:    Kalle Koseck
::    *  Date:      2007-06-02
::    *  Revision: 
::    *  File:     Call_Exit.cmd
::    *  License:  GPL / GNU General Public License
::    *
::    *  Call:
::    *
::    *    %Call_%Call_Exit "<calling-subroutine>"
::    *
::    ****************************************************
::
::
::
:Call_Exit
:: Exit /B 0
@Echo Off
If "%Call_Init_Quick%" EQU "Q" Goto Call_Exit_ExitQ
Set At=@
:: %At% Echo %0   %1   CallLevel: %CallLevel%
::
@Rem --- Echo.  Call_Exit  001
:: Goto Call_Exit_NoTime
Rem --- Time needed by routine: compute time difference
@Rem --- Echo.  Call_Exit  002

If "%SubrCall_NO%" EQU "1" Goto Call_Exit_NoTime
Set Call_Init_ProgName=%~1
If "%Call_Init_ProgName%"      EQU ""  Goto Call_Exit_NoTime
If "%Call_Init_ProgName:~0,1%" EQU "/" Goto Call_Exit_NoTime

If "%Call_Init_ProgName:~0,1%" EQU ":" Set Call_Init_ProgName=%Call_Init_ProgName:~1%
If "%Call_Init_ProgName%" NEQ "" (
	%Call_%GetTokenTime %0 %Call_Init_ProgName%
	If "!SubrCall_%Call_Init_ProgName%_TimeStrt!" EQU "" (
		(
		Set SubrCall_
		Echo.
		Echo.  Call_Exit: "Call_Init" did not set start time for: %Call_Init_ProgName%
		Echo.
		)>>"%EchoCON%"
		Pause
		Set SubrCall_NO=1
	) Else (
@Rem --- Echo.  Call_Exit  003
		Set /A SubrCall_%Call_Init_ProgName%_TimeDiff= Dat_TokenTime0 - SubrCall_%Call_Init_ProgName%_TimeStrt
		Set /A SubrCall_%Call_Init_ProgName%_TimeTotl= SubrCall_%Call_Init_ProgName%_TimeTotl + Dat_TokenTime0 - SubrCall_%Call_Init_ProgName%_TimeStrt
		Set    SubrCall_%Call_Init_ProgName%_TimeStrt=
	)
)
:Call_Exit_NoTime

@Rem --- Echo.  Call_Exit  004

%At% If "%Echo_Seen_Echo%" EQU "1" (
%At% If "%CallLevel%" EQU "1" (
	%At% If "%CallEchoOff%" EQU "1" Echo On
) )
@Rem --- Echo.  Call_Exit  005
:: %At% If "%EchoLabel:~0,2%" NEQ "::" (
::	%At% If "%1" NEQ "" %At% Echo %0 %1 %2 %3 %4 %5 %6
:: )
:: %At% Echo.  Call_Exit  CallLevel Ende: %CallLevel%
:: --- Echo all lines in main prog
@Rem --- Echo.  Call_Exit  006
%At% If "%Echo_Seen_Trace%" EQU "1" (
%At% Rem If "%Echo_Seen_Echo%" EQU "0" (
%At% %EchoLabel% ^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^ %* ^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
)

%At% Set /A CallLevelOn=%Echo_Seen_EchoLevel% + 3
%At% If %Echo_Seen_Echo% EQU 1 (
	%At% If %Echo_Seen_Init% GEQ 1 @Set CallEchoOff=0
	%At% If %CallLevel% GEQ %CallLevelOn% @Set CallEchoOff=1
)
:: echo.  %Echo_Seen_Echo% %Echo_Seen_Init% %CallLevel% %CallEchoOff%
%At% If  %CallLevel%  GEQ 0 (%At% Set /A CallLevel= %CallLevel% - 1)
@If "%CallEchoOff%" EQU "1" (Set Echo_Make=Off) Else (Set Echo_Make=On)
:: Echo.  ****************************** ^^^^^^^^^^ Call_Exit Echo: "%CallEchoOff%"="%Echo_Make%"  Level: %CallLevel%  %~1

@Echo %Echo_Make%
@Rem --- Echo.  Call_Exit  007
:Call_Exit_ExitQ
@Exit /B 0


:: ***CutEnde*** Call_Exit.cmd


:: ***CutAnfg*** GetDateTimeFormat.cmd

:: *******************************************************************
:GetDateTimeFormat
Rem vvvvvvvvvv Anfg %0 vvvvvvvvvv
@If "%Call_%" EQU "" (Set Call_=Call )
@%Call_%Call_Init %0
@%Call_%Call_Help "%~1"
%EchoLabel% %0 Input:  "%Dat_Year%" "%Dat_Month%" "%Dat_Day%" "%Dat_Hour%" "%Dat_Min%" "%Dat_Sec%" 
::
::    ****************************************************
::    *  Autor:    Kalle Koseck
::    *  File:     GetDateTimeFormat
::    *  Datum:    2007-05-28
::    *  Revision: 
::    *
::    *  License:  GPL / GNU General Public License
::    *
::    *  z.B. String Dat_Min konvert nach Intg Dat_iMin
::    *
%Hlp% *  check and format the variables:
%Hlp% *  Dat_Month, Dat_Day, Dat_Hour, Dat_Min, Dat_Sec
%Hlp% *
::    ****************************************************
%HlpExit%
::
%Call_%GetDateFormat
%Call_%GetTimeFormat

%EchoLabel% %0 Dat_*:  "%Dat_Year%" "%Dat_Month%" "%Dat_Day%" "%Dat_Hour%" "%Dat_Min%" "%Dat_Sec%" 
%EchoLabel% %0 Dat_i*: "%Dat_iYear%" "%Dat_iMonth%" "%Dat_iDay%" "%Dat_iHour%" "%Dat_iMin%" "%Dat_iSec%" 

@%Call_%Call_Exit %0
Rem ^^^^^^^^^^ Ende %0 ^^^^^^^^^^
@EXIT /B 0

:: ***CutEnde*** GetDateTimeFormat.cmd


:: ***CutAnfg*** GetDateFormat.cmd

:: *******************************************************************
:GetDateFormat
Rem vvvvvvvvvv Anfg %0 vvvvvvvvvv
@If "%Call_%" EQU "" (Set Call_=Call )
@%Call_%Call_Init %0
@%Call_%Call_Help "%~1"
::
::    ****************************************************
::    *  Autor:    Kalle Koseck
::    *  File:     GetDateFormat
::    *  Datum:    2007-05-28
::    *  Revision: 2007-10-31
::    *            2008-01-25
::    *
::    *  License:  GPL / GNU General Public License
::    *
::    *  z.B. String Dat_Min konvertiert nach Intg Dat_iMin
::    *
%Hlp% *  check and convert the variables:
%Hlp% *  Dat_Month, Dat_Day, Dat_Hour, Dat_Min, Dat_Sec
%Hlp% *
::    ****************************************************
%HlpExit%
::
:: echo on
If "%~1" NEQ ""         Set Dat_Year=%~1
If "%~2" NEQ ""         Set Dat_Month=%~2
If "%~3" NEQ ""         Set Dat_Day=%~3
%EchoLabel% %0 Input:  "%Dat_Year%" "%Dat_Month%" "%Dat_Day%" 

If "%Dat_Year%"  EQU "" Set Dat_Year=0000
If "%Dat_Month%" EQU "" Set Dat_Month=00
If  %Dat_Month%  EQU 0  Set Dat_Month=00

If "%Dat_Day%"   EQU "" Set Dat_Day=00
Rem  Ev. mit Wochentag davor: "Mi 31": "%Dat_Day%"
:: 2008-02-15
If  "%Dat_Day:~3,1%" NEQ " " Set Dat_DayInt=%Dat_Day:~3%
If  "%Dat_DayInt%"   NEQ ""  Set Dat_Day=%Dat_DayInt%

If  %Dat_Day%        EQU 0   Set Dat_Day=00

Rem  ----- Dat_Year: "%Dat_Year%"
If  %Dat_Year:~0,1% EQU 0 (
	Set /A Dat_iYear=%Dat_Year:~1%
) Else (
	Set /A Dat_iYear=%Dat_Year%
)
:: KK 2008-01-25
Set /A Dat_Year=%Dat_iYear%
If %Dat_iYear% LEQ 9 Set Dat_Year=0%Dat_Year%

Set GetDateFormat_IfMachen=0
If %Dat_iYear% LEQ 50 (
	If %Dat_iYear% GEQ 0  (
		Set GetDateFormat_IfMachen=1
		Set /A Dat_iYear= %Dat_iYear% + 2000
	)
)
If %Dat_iYear% LEQ 99 (
	If %Dat_iYear% GEQ 51  (
		Set GetDateFormat_IfMachen=1
		Set /A Dat_iYear= %Dat_iYear% + 1900
	)
)
If %GetDateFormat_IfMachen% EQU 1 (
	Set    Dat_Year=%Dat_iYear%
)

Rem  ----- Dat_Month: "%Dat_Month%" 1:"%Dat_Month:~0,1%"
If  %Dat_Month:~0,1% EQU 0 (
	Set /A Dat_iMonth=%Dat_Month:~1,1%
) Else (
	Set /A Dat_iMonth=%Dat_Month%
)
Set Dat_Month=%Dat_iMonth%
If %Dat_iMonth% LEQ 9 Set Dat_Month=0%Dat_Month%

Rem  ----- Dat_Day: "%Dat_Day%"

If  %Dat_Day:~0,1% EQU 0 (
	Set /A Dat_iDay=%Dat_Day:~1,1%
) Else (
	Set /A Dat_iDay=%Dat_Day%
)
Set Dat_Day=%Dat_iDay%
If %Dat_iDay% LEQ 9 Set Dat_Day=0%Dat_Day%

Set /A Dat_TokenDate= %Dat_iYear% * 10000 + %Dat_iMonth% * 100 + %Dat_iDay%
Set Dat_DateStr=%Dat_Year%-%Dat_Month%-%Dat_Day%

:: ----------------------------------------------
::
Set /A Dat_DayInMonth=31
If %Dat_iMonth% EQU 2   (
	Set /A Dat_DayInMonth=28
	Set /A Dat_YearS=%Dat_Year% / 4 * 4
	If %Dat_Year% EQU %Dat_YearS%  Set /A Dat_DayInMonth=29
)
If %Dat_Month% EQU 4   Set /A Dat_DayInMonth=30
If %Dat_Month% EQU 6   Set /A Dat_DayInMonth=30
If %Dat_Month% EQU 9   Set /A Dat_DayInMonth=30
If %Dat_Month% EQU 11  Set /A Dat_DayInMonth=30
:: 
%EchoLabel% %0 Dat_*:  "%Dat_Year%" "%Dat_Month%" "%Dat_Day%"
%EchoLabel% %0 Dat_i*: "%Dat_iYear%" "%Dat_iMonth%" "%Dat_iDay%"
@%Call_%Call_Exit %0  "%Dat_iYear%" "%Dat_iMonth%" "%Dat_iDay%"
Rem ^^^^^^^^^^ Ende %0 ^^^^^^^^^^
@EXIT /B 0

:: ***CutEnde*** GetDateFormat.cmd


:: ***CutAnfg*** GetTimeFormat.cmd

:: *******************************************************************
:GetTimeFormat
Rem vvvvvvvvvv Anfg %0 vvvvvvvvvv
@If "%Call_%" EQU "" (Set Call_=Call )
@%Call_%Call_Init %0
@%Call_%Call_Help "%~1"
%EchoLabel% %0 Input:  "%Dat_Hour%" "%Dat_Min%" "%Dat_Sec%" 
::
::    ****************************************************
::    *  Autor:    Kalle Koseck
::    *  File:     GetTimeFormat
::    *  Datum:    2007-08-06
::    *  Revision: 2007-09-08/2008-06-19
::    *
::    *  License:  GPL / GNU General Public License
::    *
::    *  e.g. a String Dat_Min is converted to Integer Dat_iMin
::    *
%Hlp% *  Check and format the variables:
%Hlp% *  Dat_Hour, Dat_Min, Dat_Sec, Dat_Sec0
%Hlp% *
::    ****************************************************
%HlpExit%
::
:: echo on
Goto GetTimeFormat_Goto

Set Time=
:: wenn Std UND Min UND Sek nicht angegeben sind:
If "%~1" EQU "" (
If "%~2" EQU "" (
If "%~3" EQU "" (
Set Dat_Hour=%Time:~0,2%
Set Dat_Min=%Time:~3,2%
Set Dat_Sec=%Time:~6,2%
Set Dat_Sec0=%Time:~9,2%0
)))

::   01234567890
::   10:23:55,82

:GetTimeFormat_Goto
If "%Dat_Hour%"   EQU "" Set Dat_Hour=00
If  %Dat_Hour%    EQU 0  Set Dat_Hour=00
If "%Dat_Min%"   EQU "" Set Dat_Min=00
If  %Dat_Min%    EQU 0  Set Dat_Min=00
If "%Dat_Sec%"   EQU "" Set Dat_Sec=00
If  %Dat_Sec%    EQU 0  Set Dat_Sec=00
If "%Dat_Sec0%"  EQU "" Set Dat_Sec0=00
If  %Dat_Sec0%   EQU 0  Set Dat_Sec0=00

:: -----------------------------------------------------------------
Rem  Dat_Hour: "%Dat_Hour%"
::  Wenns " 1" ist
If  "%Dat_Hour:~0,1%" EQU " " 	Set Dat_Hour=0%Dat_Hour:~1,1%
If  %Dat_Hour:~0,1% EQU 0 (
	Set Dat_iHour=%Dat_Hour:~1,1%
) Else (
	Set Dat_iHour=%Dat_Hour%
	If %Dat_Hour% LEQ 9 Set Dat_Hour=0%Dat_Hour%
)
:: -----------------------------------------------------------------
Rem  Dat_Min: "%Dat_Min%"
If  %Dat_Min:~0,1% EQU 0 (
	Set Dat_iMin=%Dat_Min:~1,1%
) Else (
	Set Dat_iMin=%Dat_Min%
	If %Dat_Min% LEQ 9 Set Dat_Min=0%Dat_Min%
)
:: -----------------------------------------------------------------
Rem  Dat_Sec: "%Dat_Sec%"
If  %Dat_Sec:~0,1% EQU 0 (
	Set Dat_iSec=%Dat_Sec:~1,2%
) Else (
	Set Dat_iSec=%Dat_Sec%
	If %Dat_Sec% LEQ 9 Set Dat_Sec=0%Dat_Sec%
)
:: -----------------------------------------------------------------
Rem  Dat_Sec0, ev. 3-Stellig: "%Dat_Sec0%"

Rem ----- Intg richtig setzen -----
Set Dat_iSec0=%Dat_Sec0%

If  %Dat_iSec0:~0,1% EQU 0 (
	Set Dat_iSec0=%Dat_iSec0:~1%
)
Rem --- jetzt Dat_iSec0: "%Dat_iSec0%"; noch eine 2. Null vorweg:
If  %Dat_iSec0:~0,1% EQU 0 (
	Set Dat_iSec0=%Dat_iSec0:~1%
)

Rem --- jetzt Dat_iSec0: "%Dat_iSec0%"
If "%Dat_iSec0%" EQU "" (Set Dat_iSec0=0)

Rem ----- aus der Intg den immer 3-stelligen String aufbauen -----
Set Dat_Sec0=%Dat_iSec0%
If %Dat_iSec0% LEQ 99 (Set Dat_Sec0=0%Dat_iSec0%)
If %Dat_iSec0% LEQ  9 (Set Dat_Sec0=00%Dat_iSec0%)

Rem --- endlich Dat_Sec0: Intg:"%Dat_iSec0%"  Strg:"%Dat_Sec0%"

If "%Dat_Sec0:~3,1%" NEQ "" (
Echo *** Fehler in Sek0 Intg:"%Dat_iSec0%"  Strg:"%Dat_Sec0%" ***
Pause
)

Set /A Dat_TokenTime= %Dat_iHour% * 3600 + %Dat_iMin% * 60 + %Dat_iSec%
Set /A Dat_TokenTime0= %Dat_TokenTime% * 1000 + %Dat_iSec0%
Set    Dat_HourMin=%Dat_Hour%%Dat_Min%
Set    Dat_HourMinSec=%Dat_Hour%%Dat_Min%%Dat_Sec%
Set    Dat_HHMMSS=%Dat_Hour%:%Dat_Min%:%Dat_Sec%
Set    Dat_TimeHHMMSS=%Dat_Hour%%Dat_Min%%Dat_Sec%
:: 
%EchoLabel% %0 Str: "%Dat_Hour%" "%Dat_Min%" "%Dat_Sec%"  "%Dat_Sec0%"
%EchoLabel% %0 Int: "%Dat_iHour%" "%Dat_iMin%" "%Dat_iSec%"  "%Dat_iSec0%"
@%Call_%Call_Exit %0
Rem ^^^^^^^^^^ Ende %0 ^^^^^^^^^^
@EXIT /B 0

:: ***CutEnde*** GetTimeFormat.cmd


