
:: ***CutAnfg*** Timer_UserInit.bat

:Timer_UserInit
Rem vvvvvvvvvv Anfg %0 vvvvvvvvvv
:: %Call_%Call_Init %0
:: %EchoLabel% :Timer_UserInit
::
::  ********************************************************************
::  *  Autor:   Kalle Koseck
::  *  Lizenz:  GNU General Public License (GPL)
::  *  Date:    2007-06-20
::  *  Revised: 2007-11-24
::  *           V14.x: Sie koennen das alte File weiter benutzen
::  *           you can keep the old file
::  *  File:    XX_UserInit.bat
::  *           XX = %Timer_Name_DiesesProg%
::  ********************************************************************


::  ********************************************************************
::  *
::  Pfad zum nach dem Reboot durch das BIOS 
::  zu startenden (beliebigen) User-Programms
::    Standard: DVBViewer.exe und Timers.xml in der Dir des DVB-Viewers
::    "%ProgramFiles%" ist normalerweise: "C:\Programme"
::
::  Path to the program that is to start after automated Reboot by the BIOS
::    default: DVBViewer.exe and Timers.xml in the Dir of  DVB-Viewers
::    "%ProgramFiles%" normally is set to: "C:\Program Files"
::
::  default: 
::    Set Timer_Dir_StartProg=%ProgramFiles%\DVBViewer
::    Set Timer_File_StartProg=%Timer_Dir_StartProg%\DVBViewer.exe
::    Set Timer_File_XML=%Timer_DVBViewer_Dir%\timers.xml
::
::  +--------------------------------------------------------
::  :
Set Timer_Dir_StartProg=%ProgramFiles%\DVBViewer
Set Timer_File_StartProg=%Timer_Dir_StartProg%\DVBViewer.exe
::  :
::  +--------------------------------------------------------

::  machs nur einmal / do only once
If "%Timer_PathSet%" EQU "" (
	Set Timer_PathSet=1
	Set PATH=%Timer_Dir_StartProg%;%PATH%
)
::
:: Set Timer_File_XML=timers.xml
Set Timer_File_XML=%Timer_Dir_StartProg%\timers.xml

::  *
::  ********************************************************************
::  *
::  Sprache, die Timer sprechen soll
::    MUSS nur geaendert werden, wenn die gewuenschte Sprache
::    von der in Windows eingestellten Sprache abweicht
::  Language to be used by Timer
::    SHOULD only be changed, if wanted language differs from
::    language set in windows
::
::    Deutsch  / German:  Set Timer_Lang=DE
::    Englisch / English: Set Timer_Lang=EN

::  Set Timer_Lang=DE
::

::  *
::  ********************************************************************

::  das temporaere Datenfile / temporary datafile
::  default:
::    Set Timer_File_Temp=%Temp%\Timer
::    Set Timer_File_Korr=%Timer_File_Temp%\Timers.korr
::
Set Timer_File_Temp=%Temp%\Timer
Set Timer_File_Korr=%Timer_File_Temp%\Timers.korr
::  *
::  ********************************************************************
::  User defaults:

::  Zeit, zu der das BIOS den Rechner wieder startet
::    !!! MUSS im BIOS genau so gesetzt sein !!!
::
::    immer HINTER das heutige Datum setzen (spaeter)
::    sonst loescht DVBViewer sofort alle aufzunehmenden
::    Programme, wenn es noch aktiv ist
::    (Das Jahr ist vollkommen egal, nur Windows muss es koennen)
::
::    ACHTUNG: Diese Zeit bitte NICHT aendern.
::    Eine andere Zeit ist z.Zt. nicht unterstuetzt.
::

::  Time set in BIOS when the computer should be restarted
::    !!! has to be set in the BIOS with these parameters !!!
::
::    has to be a time earlier than the actual time of day
::    otherwise DVBViewer closes all recordings and deletes
::    all programs to be recorded in the future
::    (The year is normally not of interest - most BIOSes do not
::    support years - only Windows has to recognize it correctly)
::
::    ATTENTION: Do NOT change this time.
::    Other times may not be supported by Timer.
::
Set /A Timer_BiosRestartDateYYYY= 2001
Set /A Timer_BiosRestartDateMM= 1
Set /A Timer_BiosRestartDateTT= 31
Set /A Timer_BiosRestartTimeStd= 23
Set /A Timer_BiosRestartTimeMin= 59
Set /A Timer_BiosRestartTimeSek= 59

::  Sicherheitszeit, die der Computer vor der Startzeit
::  bereit sein soll (die Zeit vom Booten bis zum laufenden
::  Windows wird noch zusaetzlich hinzuaddiert)
::
::  Beispiel:
::  Startzeit der Aufnahme:     20:15
::  Boot bis laufendes Windows: -2:00
::  Sicherheitszeit:            -1:00
::                             ------
::  Startzeit des BIOS:         20:12
::  

::  Security time: Time from working Windows til start of the
::  recording
::  (The time from boot til working Windows is not included in
::  this parameter)
::
::  Example:
::  Recording starting at      20:15
::  Boot til running Windows:  -2:00
::  Security time:             -1:00
::                             -----
::  Starttime of BIOS:         20:12

::  Default: Set /A Timer_WindowsStartSek= 60

Set /A Timer_WindowsStartSek= 60
::  *
::  ********************************************************************

:: wenn die naechste Aufnahme in weniger als xx Sekunden
::   bevorsteht, Rechner nicht herunterfahren
::   default (deaktiviert): "... *0"
::

:: Start of next recording in less than xx seconds
::   then do not shut down the computer
::   default (deactivated): "... *0"
::
Set /A Timer_RestartNichtMachenSek= 15 * 60  *0
::  *
::  ********************************************************************

::  Systemzeit kann durch Timer umgestellt werden
::  System time can be changed by Timer
::
::    default: aktiviert, die Systemzeit wird umgestellt:
::    default: activated, system time is changed:
::    Set    Timer_SetDateUndTime=
::    Rem . 
::
::    deaktiviert, wenn gleich "Rem " / deactivated if set to "Rem "
::    Set    Timer_SetDateUndTime=Rem . 

Set    Timer_SetDateUndTime=
Rem . 
::  *
::  ********************************************************************
::
:: %Call_%Call_Exit
Rem ^^^^^^^^^^ Ende %0 ^^^^^^^^^^
Exit /B 0

:: ***CutEnde*** Timer_UserInit.bat
