
::  ****************************************************
::  *  File:      Timer_UserPara_Test.bat
::  *  
::  *  Rename to: Timer_UserPara.bat
::  *  
::  *             If renamed this file will be used to
::  *             set the next starting time
::  *  
::  *             Wenn dieses File renamed wird, so wird
::  *             es beim naechsten Aufruf von Timer
::  *             benutzt, um die Startzeit zu setzen
::  *  
::  *  Generated by: Timer_UserPara_Test_All_Make.cmd
::  *  Date:      2007-11-17
::  *  Revised:   2008-02-01
::  *  
::  *  Test-Program:
::  *  
::  *  setzt die naechste STARTzeit auf akt. Uhr + 15 min.
::  *  setzt die naechste   ENDzeit auf akt. Uhr + 20 min.
::  *  
::  *  sets the next time to START to act. time + 15 min.
::  *  sets the next time to   END to act. time + 20 min.
::  *  
::  ****************************************************

Set Call_=Call :
@Call :Call_Init
Set Call_=Call :

:: ***CutAnfg*** Timer_UserPara_Test_Vorlage.BAT

:: echo on
Rem vvvvvvvvvv Anfg %0 vvvvvvvvvv
Rem ---  Timer_UserPara.BAT

::  *********************************************************
::  *  Autor:   Kalle Koseck
::  *  License: GPL / GNU General Public License
::  *  Date:    2007-11-16
::  *  Revised: 
::  *  File:    Timer_UserPara.BAT
::  *
::  *       Nr Bedeutung       meaning        Timer_UserPara_
::  *          Nr der Zeile    No of Row      TUP_RecNo
::  *  Para  1 Programmname    Program        TUP_Prog  : %~1
::  *  Para  2 Sendername      Name Transm.   TUP_Send  : %~2
::  *  Para  3 Datum-Ein       Date Start     TUP_DateS : %~3
::  *  Para  4 Zeit-Ein        Time Start     TUP_TimeS : %~4
::  *  Para  5 Zeit-Aus        Time End       TUP_TimeE : %~5
::  *  Para  6 am Ende         when finished  TUP_End   : %~6
::  *  Para  7 Wochentag       Day of Week    TUP_Day   : %~7
::  *  Para  8 ?               ?              TUP_8     : %~8
::  *  Para  9 aktiviert       activated      TUP_Activ : %~9
::  *  Para 10 ?               ?              TUP_10    :
::  *
::  *  Para  6:
::  *    0=Kein                  1=erzwinge Herunterfahren
::  *    2=erzwinge Standby      3=erzw Ruhemodus
::  *    4=schliesse DVB-Viewer  5=starte Playlist
::  *    6=DVBViewer Ruhemodus
::  *
::  *  Ende, wenn Variable geloescht:
::  *  End,  if variable is deleted:
::  *
::  *    Set TUP_DateS=
::  *
::  *********************************************************

:: Es gibt 2 Mglichkeiten, die Zeit zu setzen:
:: 1. Datum und Zeit angeben
:: 2. Verschiedene Startzeiten angeben, aus denen die nchste genommen wird

Goto Methode2
:: ==========================================================
:: 1. Methode: es gibt nur eine Startzeit
::             Datum und Zeit direkt angeben

Set Timer_Manuell_DateStr=10.06.2007
Set Timer_Manuell_TimeStr=20:12:15
Exit /B 0

:: ==========================================================
:: 2. Methode: Verschiedene Startzeiten angeben,
::             aus denen die nchste genommen wird
::
:: ---  es ist notwendig, diese 3 Variablen zu setzen:
::      alle anderen koennen undefiniert bleiben
:: ---  necessary to set these 3 variables:
::      all others may be left undefined
::
::      TUP_DateS   TUP_TimeS   TUP_TimeE=
::
::      TUP_DateS
::          undefiniert: keine weiteren Startzeiten
::          left undefined: no further start times
::
::      TUP_Activ:
::          Grosse  = kleine Buchstaben
::          aktiv   = undefiniert|T|... alles was nicht passiv ist
::          passiv  = NO|N|0(=Null)|NEIN|FALSE
::
::          not case sensitive
::          active  = undefined|T|...or everything not passive
::          passive = NO|N|0(=null)|NEIN|FALSE

:Methode2
%Call_%GetDateTime
Set /A Dat.New1=Dat_TokenTime     + 15 * 60
%Call_%GetIntgDateToYYYYMMDD %Dat_TokenDate% %Dat.New1%
Set    TUPTimeAS=%Dat_Hour%:%Dat_Min%:%Dat_Sec%
Set /A TUP_TimeDiff= 5 * 60
Set /A Dat.New2=Dat.New1          +  %TUP_TimeDiff%
%Call_%GetIntgDateToYYYYMMDD %Dat_TokenDate% %Dat.New2%
Set TUPTimeAE=%Dat_Hour%:%Dat_Min%:%Dat_Sec%

Set TUP_Prog=
Set TUP_Send=
Set TUP_DateS=
Set TUP_TimeS=
Set TUP_TimeE=
Set TUP_End=
Set TUP_Day=
Set TUP_Activ=
Set TUP_8=
Set TUP_10=
Set TUP_Simulate=0

If "%TUP_RecNo%" EQU "1" (
Set TUP_DateS=%Dat_DateStr%
Set TUP_TimeS=%TUPTimeAS%
Set TUP_TimeE=%TUPTimeAE%
Set TUP_Simulate=1

Set TUP_Prog=Programm 1
Set TUP_Send=
Set TUP_End=
Set TUP_Day=
Set TUP_Activ=
)
If "%TUP_RecNo%" EQU "2" (
Set TUP_DateS=2007-11-30
Set TUP_TimeS=20:00:15
Set TUP_TimeE=21:45:00

Set TUP_Prog=Programm 2
Set TUP_Send=
Set TUP_End=
Set TUP_Day=
Set TUP_Activ=
)

:: if start-date is set but activ set to nothing: activate
If "%TUP_DateS%" NEQ "" (
	If "%TUP_Activ%" EQU "" Set TUP_Activ=yes
)
Rem ^^^^^^^^^^ Ende %0 ^^^^^^^^^^
Exit /B 0

:: ***CutEnde*** Timer_UserPara_Test_Vorlage.BAT

:: ***CutAnfg*** Call_Init.cmd

:Call_Init
::
::  ****************************************************
::  *  Autor:    Kalle Koseck
::  *  Datum:    2007-06-02
::  *  Revised:  2007-11-01
::  *  File:     Call_Init.cmd
::  *  License:  GPL / GNU General Public License
::  *
::  *  Call:
::  *    %Call_%Call_Init
::  *
::  *  Parameter:
::  *
::  *    Init On Off
::  *
::  ****************************************************
::
@Set @At=@
:: echo on
%@At% Rem vvvvvvvvvv Anfg %0 vvvvvvvvvv
%@At% Set Call_Init.cmd_Prog=%~0
%@At% Set Call_Init.cmd_Init=0
::
:Call_Init.cmd_Para
%@At% Rem --- :Call_Init.cmd_Para Para1: "%~1"
%@At% If /I "%~1" EQU "INIT" (
	%@At% Rem Echo *** "%~1" INIT gesehen
	%@At% Call :Call_Init.Init
	Shift
	Goto Call_Init.cmd_Para
)
::
%@At% If /I "%~1" EQU "OFF" (
	%@At% Rem Echo *** "%~1" OFF gesehen
	%@At% Set CallLevel=-1
	%@At% rem Echo Off
	Shift
	Goto Call_Init.cmd_Para
)
::
%@At% If /I "%~1" EQU "ON" (
	%@At% Rem Echo *** "%~1" ON gesehen
	%@At% Call :Call_Init.Init
	%@At% Set CallLevel=-1
	%@At% Set CallEchoOff=0
	%@At% Echo On
	Shift
	Goto Call_Init.cmd_Para
)
::
:: 
%@At% If "%CallEchoOff%" EQU "" (%@At% Call :Call_Init.Init N)
:: --------------------------------------------------------------------
%@At% Rem --- CallLevel: %CallLevel%
%@At% If "%EchoLabel%" EQU "" Set EchoLabel=Rem --- Label --- 
%@At% If "%EchoCON%"   EQU "" Set   EchoCON=CON
%@At% If "%EchoNUL%"   EQU "" Set   EchoNUL=NUL
%@At% If "%OutCon%"    EQU "" Set    Outcon=CON
%@At% If "%CallLevel%" EQU "" Set CallLevel=0
%@At% If "%Error%"     EQU "" Set     Error=0
::
::
:: --- wenn noch unbekannte Parameter uebrig sind: anzeigen
%@At% If "%~1" NEQ "" (
%@At% If "%Call_Init.cmd_Prog:~0,1%" NEQ ":" (
%@At% %EchoLabel% %Call_Init.cmd_Prog% "%~1" "%~2" "%~3" "%~4" "%~5"
) )

%@At% Rem %Call_Init.cmd_Prog%   Para=%~1   CallLevel: %CallLevel%
::
%@At% If     %CallLevel%  GEQ 0 %@At% Set /A CallLevel= %CallLevel% + 1
%@At% If    "%CallLevel%" EQU "-1" (
%@At% If /I "%Debug%"       EQU "ECHO" (Echo On) Else (Echo Off)
%@At% If /I "%CallEchoOff%" EQU "0"    (Echo On) Else (Echo Off)
)
%@At% If "%CallLevel%" EQU "1" (
	%@At% If "%CallEchoOff%" EQU "1" Echo Off
)
::
:: set call & set echo
:Call_Init_Exit

%@At% If "%Call_%" EQU "" (
	%@At% Call :Call_Init.Init
	Echo.
	Echo.  Bitte VORHER aufrufen / Please call BEFORE:
	Echo.
	Echo.    "Call Call_Init"
	Echo.
	Pause
)

%@At% Rem ^^^^^^^^^^ Ende %0 ^^^^^^^^^^
%@At% EXIT /B 0

===========================================================================
*** Subroutinen ***

:Call_Init.Init
%@At% Rem vvvvvvvvvv %0

	%@At% Set   EchoLabel=Rem *** Label: 
	%@At% Set     EchoCON=CON
	%@At% Set     EchoNUL=NUL
	%@At% Set   EchoDelay=0
	%@At% Set      Outcon=CON
	%@At% If "%~1" EQU "" (%@At% If "%Call_%" EQU "" (%@At% Set Call_=Call ) )
	%@At% Set   CallLevel=0
	%@At% Set CallEchoOff=1
	%@At% Set       Error=0

%@At% Rem ^^^^^^^^^^ %0
%@At% EXIT /B 0

:: ***CutEnde*** Call_Init.cmd


:: ***CutAnfg*** Call_Exit.cmd

:Call_Exit
::
::  ****************************************************
::  *  Autor:    Kalle Koseck
::  *  Datum:    2007-06-02
::  *  Revision: 
::  *  File:     Call_Exit.cmd
::  *  License:  GPL / GNU General Public License
::  *
::  *  Call:
::  *    %Call_%Call_Exit
::  *
::  ****************************************************
::
::
:: @Echo %0   %1   CallLevel: %CallLevel%
::
@If "%CallLevel%" EQU "1" (
	@If "%CallEchoOff%" EQU "1" Echo On
)
:: @If "%EchoLabel:~0,2%" NEQ "::" (
::	@If "%1" NEQ "" @Echo %0 %1 %2 %3 %4 %5 %6
:: )
@If  %CallLevel%  GEQ 0 (@Set /A CallLevel= %CallLevel% - 1)
@Exit /B 0

:: ***CutEnde*** Call_Exit.cmd




:: ***CutAnfg*** GetAllUsersAppData.cmd

:: *******************************************************************
:GetAllUsersAppData
Rem vvvvvvvvvv Anfg %0 vvvvvvvvvv
@If "%Call_%" EQU "" (Set Call_=Call )
@%Call_%Call_Init %0
::
:: *******************************************************************
::  *  Autor:    Kalle Koseck
::  *  File:     GetAllUsersAppData
::  *  Datum:    2007-08-19
::  *  Revision: 
::  *
::  *  License:  GPL / GNU General Public License
::  *
::  *  e.g. "C:\Documents and Settings\All Users\Application Data"
::  *
Rem *  Para1: String: name of variable to return directory
Rem *         "%~1"
::  *
:: *******************************************************************
::
::
:: set AppData

If "%~1" EQU "" (
	Set GetAllUsersAppData_Return=AllUsersAppData
) Else (
	Set GetAllUsersAppData_Return=%~1
)

Set AppData >%Temp%\GetAllUsersAppData.tmp
FOR /F "usebackq Delims=\ Tokens=4" %%A in (%Temp%\GetAllUsersAppData.tmp) do Set AppDataPart=%%A

Set %GetAllUsersAppData_Return%=%AllUsersProfile%\%AppDataPart%
Set  GetAllUsersAppData_Return=

%EchoLabel% AllUsersAppData: %AllUsersAppData%
@%Call_%Call_Exit %0
Rem %GetAllUsersAppData_Return%:   %AllUsersProfile%\%AppDataPart%
Rem ^^^^^^^^^^ Ende %0 ^^^^^^^^^^
@EXIT /B 0

:: ***CutEnde*** GetAllUsersAppData.cmd


:: ***CutAnfg*** GetDateTime.cmd

:: *******************************************************************
:GetDateTime
Rem vvvvvvvvvv Anfg %0 vvvvvvvvvv
@If "%Call_%" EQU "" (Set Call_=Call )
@%Call_%Call_Init %0
%EchoLabel% %0 Para: "%~1" "%~2"
::
::  ****************************************************
::  *  Autor:    Kalle Koseck
::  *  Datum:    2006-01-10
::  *  Revision: 2007-05-28
::  *  Revision: 2007-11-15
::  *  File:     GetDateTime.cmd
::  *  License:  GPL / GNU General Public License
::  *
::  *  Input:
Rem *    String: Datum ODER Zeit Format: TT.MM.YYYY / HH:MM[:SS]
Rem *    Para 1: "%~1"
::  *    ist der String leer (nicht angegeben),
::  *    so wird die aktuelle Zeit genommen
::  *    ist hier die Zeit angegeben, so wird als default
::  *    das aktuelle Datum genommen
::
Rem *    String: Zeit  Format: HH:MM:SS oder HH:MM
Rem *    Para 2: "%~2"
::  *    ist der String leer (nicht angegeben),
::  *    so wird die aktuelle Zeit genommen
::
::  *  es gibt 2 verschiedene interne Datum-Formate:
::  *  deutsch:  "Di 10.01.2006"  und
::  *  englisch: "10.01.2006"     und womoeglich noch mehr ...
::  *             0123456789.123
::  *
::  ****************************************************
::
Set Date=
Set Time=
If "%~2" EQU "" (
	Set Time=%~1
	Set Date=%~2
) Else (
	If "%~1" NEQ "" ( Set Date=%~1)
	If "%~2" NEQ "" ( Set Time=%~2)
)

Rem --- Datum/Zeit:  "%Date%"  "%Time%"

Rem --- HH:MM:SS,00
For /F "delims=: tokens=1-3" %%A IN ("%Time%") do (
	Set Dat_Hour=%%A
	Set Dat_Min=%%B
	Set Dat_Sec=%%C
)
If "%Dat_Sec%" EQU "" Set Dat_Sec=00

Rem --- Sekunden: z.B. 23,45 mit Komma
For /F "delims=, tokens=1-3" %%A IN ("%Dat_Sec%") do (
	Set Dat_Sec=%%A
	Set Dat_Sec0=%%B
)
Rem --- Sekunden: z.B. 23.45 mit Punkt
If "%Dat_Sec0%" EQU "" (
For /F "delims=. tokens=1-3" %%A IN ("%Dat_Sec%") do (
	Set Dat_Sec=%%A
	Set Dat_Sec0=%%B
) )
If "%Dat_Sec0%" EQU "" (
	Set Dat_Sec0=00
	Set /A Dat_iSec0=0
)

::----------------------------------------------------------------
Rem --- DD.MM.YYYY
For /F "delims=. tokens=1-3" %%A IN ("%Date%") do (
	Set Dat_Year=%%C
	Set Dat_Month=%%B
	Set Dat_Day=%%A
)

Rem --- YYYY-MM-DD
If "%Dat_Month%" EQU "" (
	For /F "delims=- tokens=1-3" %%A IN ("%Date%") do (
		Set Dat_Year=%%A
		Set Dat_Month=%%B
		Set Dat_Day=%%C
	)
)
:: -------------------------------------------
Rem --- Dat_Year: "Mo 2007-..." / "%Dat_Year%"
For /F "tokens=1-2" %%A IN ("%Dat_Year%") do (
	Set Dat_DayName=%%A
	Set Dat_Year=%%B
)
Rem --- no name of day, was: "2007-..."
If "%Dat_Year%" EQU "" (
	Set Dat_Year=%Dat_DayName%
	Set Dat_DayName=-
)

If "%Dat_Min%" EQU "" (
(
	Echo.  *
	Echo.  **************************************************************
	Echo.  *
	Echo.  *  ***Fatal***: Routine: %0
	Echo.  *  Das Zeit-Format wurde nicht erkannt: "%Time%"
	Echo.  *
	Echo.  **************************************************************
	Echo.  *
	) >%OutCon%
	%Color_CMD_Error%
	Pause *** Fataler Fehler ***
	Goto :GetDateTime_Fehler
)
If "%Dat_Month%" EQU "" (
	(
	Echo.  *
	Echo.  **************************************************************
	Echo.  *
	Echo.  *  ***Fatal***: Routine: %0
	Echo.  *  Das Datum-Format wurde nicht erkannt: "%Date%"
	Echo.  *
	Echo.  **************************************************************
	Echo.  *
	) >%OutCon%
	%Color_CMD_Error%
	Pause *** Fataler Fehler ***
:GetDateTime_Fehler
Set Dat_Year=0
Set Dat_Month=0
Set Dat_Day=0
Set Dat_Hour=0
Set Dat_Min=0
Set Dat_Sec=0
Echo Unknown date/time: %Date%" "%Time%" > _GetDateTime_Unknown.txt
)

Set Date=
Set Time=
%Call_%GetDateTimeFormat

Set Dat_DateStr=%Dat_Year%-%Dat_Month%-%Dat_Day%

:: 
:GetDateTime_Ende
%EchoLabel% %0_Ende
@%Call_%Call_Exit %0
Rem ^^^^^^^^^^ Ende %0 "%Dat_iYear%" "%Dat_iMonth%" "%Dat_iDay%" "%Dat_iHour%" "%Dat_iMin%" "%Dat_iSec%" ^^^^^^^^^^
@EXIT /B 0

:: ***CutEnde*** GetDateTime.cmd


:: ***CutAnfg*** GetDateTimeFormat.cmd

:: *******************************************************************
:GetDateTimeFormat
Rem vvvvvvvvvv Anfg %0 vvvvvvvvvv
@If "%Call_%" EQU "" (Set Call_=Call )
@%Call_%Call_Init %0
%EchoLabel% %0 Input:  "%Dat_Year%" "%Dat_Month%" "%Dat_Day%" "%Dat_Hour%" "%Dat_Min%" "%Dat_Sec%" 
::
::  ****************************************************
::  *  Autor:    Kalle Koseck
::  *  File:     GetDateTimeFormat
::  *  Datum:    2007-05-28
::  *  Revision: 
::  *
::  *  License:  GPL / GNU General Public License
::  *
::  *  z.B. String Dat_Min konvert nach Intg Dat_iMin
::  *
::  *  fuer die Variablen:
::  *  Dat_Month, Dat_Day, Dat_Hour, Dat_Min, Dat_Sec
::  *
::  ****************************************************
::
::
%Call_%GetDateFormat
%Call_%GetTimeFormat

%EchoLabel% %0 Dat_*:  "%Dat_Year%" "%Dat_Month%" "%Dat_Day%" "%Dat_Hour%" "%Dat_Min%" "%Dat_Sec%" 
%EchoLabel% %0 Dat_i*: "%Dat_iYear%" "%Dat_iMonth%" "%Dat_iDay%" "%Dat_iHour%" "%Dat_iMin%" "%Dat_iSec%" 

@%Call_%Call_Exit %0
Rem ^^^^^^^^^^ Ende %0 ^^^^^^^^^^
@EXIT /B 0

:: ***CutEnde*** GetDateTimeFormat.cmd


:: ***CutAnfg*** GetDateFormat.cmd

:: *******************************************************************
:GetDateFormat
Rem vvvvvvvvvv Anfg %0 vvvvvvvvvv
@If "%Call_%" EQU "" (Set Call_=Call )
@%Call_%Call_Init %0
::
::  ****************************************************
::  *  Autor:    Kalle Koseck
::  *  File:     GetDateFormat
::  *  Datum:    2007-05-28
::  *  Revision: 2007-10-31
::  *            2008-01-25
::  *
::  *  License:  GPL / GNU General Public License
::  *
::  *  z.B. String Dat_Min konvertiert nach Intg Dat_iMin
::  *
::  *  fuer die Variablen:
::  *  Dat_Month, Dat_Day, Dat_Hour, Dat_Min, Dat_Sec
::  *
::  ****************************************************
::
::
If "%~1" NEQ ""         Set Dat_Year=%~1
If "%~2" NEQ ""         Set Dat_Month=%~2
If "%~3" NEQ ""         Set Dat_Day=%~3
%EchoLabel% %0 Input:  "%Dat_Year%" "%Dat_Month%" "%Dat_Day%" 

If "%Dat_Year%"  EQU "" Set Dat_Year=0000
If "%Dat_Month%" EQU "" Set Dat_Month=00
If  %Dat_Month%  EQU 0  Set Dat_Month=00

If "%Dat_Day%"   EQU "" Set Dat_Day=00
Rem  Ev. mit Wochentag davor: "Mi 31"
If  "%Dat_Day:~2,1%" EQU " " Set Dat_Day=%Dat_Day:~3%

If  %Dat_Day%    EQU 0  Set Dat_Day=00

Rem  ----- Dat_Year: "%Dat_Year%"
If  %Dat_Year:~0,1% EQU 0 (
	Set /A Dat_iYear=%Dat_Year:~1%
) Else (
	Set /A Dat_iYear=%Dat_Year%
)
:: KK 2008-01-25
Set /A Dat_Year=%Dat_iYear%
If %Dat_iYear% LEQ 9 Set Dat_Year=0%Dat_Year%

Set GetDateFormat_IfMachen=0
If %Dat_iYear% LEQ 50 (
	If %Dat_iYear% GEQ 0  (
		Set GetDateFormat_IfMachen=1
		Set /A Dat_iYear= %Dat_iYear% + 2000
	)
)
If %Dat_iYear% LEQ 99 (
	If %Dat_iYear% GEQ 51  (
		Set GetDateFormat_IfMachen=1
		Set /A Dat_iYear= %Dat_iYear% + 1900
	)
)
If %GetDateFormat_IfMachen% EQU 1 (
	Set    Dat_Year=%Dat_iYear%
)

Rem  ----- Dat_Month: "%Dat_Month%" 1:"%Dat_Month:~0,1%"
If  %Dat_Month:~0,1% EQU 0 (
	Set /A Dat_iMonth=%Dat_Month:~1,1%
) Else (
	Set /A Dat_iMonth=%Dat_Month%
)
Set Dat_Month=%Dat_iMonth%
If %Dat_iMonth% LEQ 9 Set Dat_Month=0%Dat_Month%

Rem  ----- Dat_Day: "%Dat_Day%"

If  %Dat_Day:~0,1% EQU 0 (
	Set /A Dat_iDay=%Dat_Day:~1,1%
) Else (
	Set /A Dat_iDay=%Dat_Day%
)
Set Dat_Day=%Dat_iDay%
If %Dat_iDay% LEQ 9 Set Dat_Day=0%Dat_Day%

Set /A Dat_TokenDate= %Dat_iYear% * 10000 + %Dat_iMonth% * 100 + %Dat_iDay%

:: ----------------------------------------------
::
Set /A Dat_DayInMonth=31
If %Dat_iMonth% EQU 2   (
	Set /A Dat_DayInMonth=28
	Set /A Dat_YearS=%Dat_Year% / 4 * 4
	If %Dat_Year% EQU %Dat_YearS%  Set /A Dat_DayInMonth=29
)
If %Dat_Month% EQU 4   Set /A Dat_DayInMonth=30
If %Dat_Month% EQU 6   Set /A Dat_DayInMonth=30
If %Dat_Month% EQU 9   Set /A Dat_DayInMonth=30
If %Dat_Month% EQU 11  Set /A Dat_DayInMonth=30
:: 
%EchoLabel% %0 Dat_*:  "%Dat_Year%" "%Dat_Month%" "%Dat_Day%"
%EchoLabel% %0 Dat_i*: "%Dat_iYear%" "%Dat_iMonth%" "%Dat_iDay%"
@%Call_%Call_Exit %0
Rem ^^^^^^^^^^ Ende %0 ^^^^^^^^^^
@EXIT /B 0

:: ***CutEnde*** GetDateFormat.cmd


:: ***CutAnfg*** GetTimeFormat.cmd

:: *******************************************************************
:GetTimeFormat
Rem vvvvvvvvvv Anfg %0 vvvvvvvvvv
@If "%Call_%" EQU "" (Set Call_=Call )
@%Call_%Call_Init %0
%EchoLabel% %0 Input:  "%Dat_Hour%" "%Dat_Min%" "%Dat_Sec%" 
::
::  ****************************************************
::  *  Autor:    Kalle Koseck
::  *  File:     GetTimeFormat
::  *  Datum:    2007-08-06
::  *  Revision: 2007-09-08
::  *
::  *  License:  GPL / GNU General Public License
::  *
::  *  z.B. String Dat_Min konvert nach Intg Dat_iMin
::  *
::  *  fuer die Variablen:
::  *  Dat_Hour, Dat_Min, Dat_Sec
::  *
::  ****************************************************
::
::
Goto GetTimeFormat_Goto

Set Time=
:: wenn Std UND Min UND Sek nicht angegeben sind:
If "%~1" EQU "" (
If "%~2" EQU "" (
If "%~3" EQU "" (
Set Dat_Hour=%Time:~0,2%
Set Dat_Min=%Time:~3,2%
Set Dat_Sec=%Time:~6,2%
)))


:GetTimeFormat_Goto
If "%Dat_Hour%"   EQU "" Set Dat_Hour=00
If  %Dat_Hour%    EQU 0  Set Dat_Hour=00
If "%Dat_Min%"   EQU "" Set Dat_Min=00
If  %Dat_Min%    EQU 0  Set Dat_Min=00
If "%Dat_Sec%"   EQU "" Set Dat_Sec=00
If  %Dat_Sec%    EQU 0  Set Dat_Sec=00
If "%Dat_Sec0%"  EQU "" Set Dat_Sec0=00
If  %Dat_Sec0%   EQU 0  Set Dat_Sec0=00

:: -----------------------------------------------------------------
Rem  Dat_Hour: "%Dat_Hour%"
::  Wenns " 1" ist
If  "%Dat_Hour:~0,1%" EQU " " 	Set Dat_Hour=0%Dat_Hour:~1,1%
If  %Dat_Hour:~0,1% EQU 0 (
	Set Dat_iHour=%Dat_Hour:~1,1%
) Else (
	Set Dat_iHour=%Dat_Hour%
	If %Dat_Hour% LEQ 9 Set Dat_Hour=0%Dat_Hour%
)
:: -----------------------------------------------------------------
Rem  Dat_Min: "%Dat_Min%"
If  %Dat_Min:~0,1% EQU 0 (
	Set Dat_iMin=%Dat_Min:~1,1%
) Else (
	Set Dat_iMin=%Dat_Min%
	If %Dat_Min% LEQ 9 Set Dat_Min=0%Dat_Min%
)
:: -----------------------------------------------------------------
Rem  Dat_Sec: "%Dat_Sec%"
If  %Dat_Sec:~0,1% EQU 0 (
	Set Dat_iSec=%Dat_Sec:~1,2%
) Else (
	Set Dat_iSec=%Dat_Sec%
	If %Dat_Sec% LEQ 9 Set Dat_Sec=0%Dat_Sec%
)
:: -----------------------------------------------------------------
Rem  Dat_Sec0, ev. 3-Stellig: "%Dat_Sec0%"

Rem ----- Intg richtig setzen -----
Set Dat_iSec0=%Dat_Sec0%

If  %Dat_iSec0:~0,1% EQU 0 (
	Set Dat_iSec0=%Dat_iSec0:~1%
)
Rem --- jetzt Dat_iSec0: "%Dat_iSec0%"; noch eine 2. Null vorweg:
If  %Dat_iSec0:~0,1% EQU 0 (
	Set Dat_iSec0=%Dat_iSec0:~1%
)

Rem --- jetzt Dat_iSec0: "%Dat_iSec0%"
If "%Dat_iSec0%" EQU "" (Set Dat_iSec0=0)

Rem ----- aus der Intg den immer 3-stelligen String aufbauen -----
Set Dat_Sec0=%Dat_iSec0%
If %Dat_iSec0% LEQ 99 (Set Dat_Sec0=0%Dat_iSec0%)
If %Dat_iSec0% LEQ  9 (Set Dat_Sec0=00%Dat_iSec0%)

Rem --- endlich Dat_Sec0: Intg:"%Dat_iSec0%"  Strg:"%Dat_Sec0%"

If "%Dat_Sec0:~3,1%" NEQ "" (
Echo *** Fehler in Sek0 Intg:"%Dat_iSec0%"  Strg:"%Dat_Sec0%" ***
Pause
)

Set /A Dat_TokenTime= %Dat_iHour% * 3600 + %Dat_iMin% * 60 + %Dat_iSec%
Set /A Dat_TokenTime0= %Dat_TokenTime% * 1000 + %Dat_iSec0%
Set    Dat_HourMin=%Dat_Hour%%Dat_Min%
Set    Dat_HourMinSec=%Dat_Hour%%Dat_Min%%Dat_Sec%
Set    Dat_HHMMSS=%Dat_Hour%:%Dat_Min%:%Dat_Sec%
:: 
%EchoLabel% %0 Str: "%Dat_Hour%" "%Dat_Min%" "%Dat_Sec%"  "%Dat_Sec0%"
%EchoLabel% %0 Int: "%Dat_iHour%" "%Dat_iMin%" "%Dat_iSec%"  "%Dat_iSec0%"
@%Call_%Call_Exit %0
Rem ^^^^^^^^^^ Ende %0 ^^^^^^^^^^
@EXIT /B 0

:: ***CutEnde*** GetTimeFormat.cmd



:: ***CutAnfg*** GetIntgDateToYYYYMMDD

:GetIntgDateToYYYYMMDD
Rem vvvvvvvvvv Anfg %0 vvvvvvvvvv
@If "%Call_%" EQU "" (Set Call_=Call )
@%Call_%Call_Init %0
%EchoLabel% %0 Para: "%1" "%2"
::  ****************************************************
::  *  Autor:   Kalle Koseck
::  *  License: GPL / GNU General Public License
::  *  Date:    2007-04-08
::  *  File:    GetIntgDateToYYYYMMDD
::  *
::  *  Input:
::  *
Rem *  Para 1: Integer Date as TokenDate (YYYY * 10000 + MM * 100 + TT)
Rem *         %1
::  *
Rem *  Para 2: Integer Time as TokenTime (0 .. 86399 Sek.)
Rem *         %2
::  *  
::  *         Example:
::  *         20070528
::  *
::  *  Output:
::  *
::  *    Dat_Year, Dat_Month, Dat_Day
::  *
::  ****************************************************
::

Set /A Dat_Year= %~1 / 10000
Set /A Dat_Month= (%~1 - (Dat_Year * 10000) ) / 100
Set /A Dat_Day=    %~1 - (Dat_Year * 10000) - (Dat_Month * 100)

%Call_%GetDateTimeFormat

If "%2" EQU "" (
@%Call_%Call_Exit %0
Rem ^^^^^^^^^^ Ende %0 "%Dat_iYear%" "%Dat_iMonth%" "%Dat_iDay%" ^^^^^^^^^^
@EXIT /B 0
)

%Call_%GetIntgTimeToHHMMSS %~2

@%Call_%Call_Exit %0
Rem ^^^^^^^^^^ Ende %0 "%Dat_iYear%" "%Dat_iMonth%" "%Dat_iDay%" "%Dat_iHour%" "%Dat_iMin%" "%Dat_iSec%" ^^^^^^^^^^
@EXIT /B 0

:: ***CutEnde*** GetIntgDateToYYYYMMDD



:: ***CutAnfg*** GetIntgTimeToHHMMSS.cmd

:: *********************************************************************
:GetIntgTimeToHHMMSS
Rem vvvvvvvvvv Anfg %0 vvvvvvvvvv
@If "%Call_%" EQU "" (Set Call_=Call )
@%Call_%Call_Init %0
%EchoLabel% %0 Para: %~1
::  ****************************************************
::  *  Autor:    Kalle Koseck
::  *  License:  GPL / GNU General Public License
::  *  Date:     2007-05-26
::  *  Revision: 2007-09-10
::  *  File:     GetIntgTimeToHHMMSS.cmd
::  *
::  *  *************************************************
::  *  Input:
Rem *    Para 1: Integer: TokenTime: "%~1"
::
Rem *    Para 2: Schalter : "%~2" "%~3" "%~4"
::  *            "Sek0"   Zeit in tausendstel
::  *                     125456 = 2:05.456
::  *            "1"      nur die notwendigen Teile ausgeben
::  *            fehlt    sonst HH:MM:SS(.000)
::  *
::  *  Output:
::  *    Dat_Hour  Dat_Min  Dat_Sec
::  *    Dat_TimeHHMMSS
::  *
::  *
::  ****************************************************

Set GetIntgTimeToHHMMSS.cmd=%0
Set GetIntgTimeToHHMMSS.cmd_Sek0=0
Set GetIntgTimeToHHMMSS.cmd_Notwendig=0
Set GetIntgTimeToHHMMSS.cmd_Zeit=%~1

:GetIntgTimeToHHMMSS.cmd_Anfg
Shift
Rem --- Parameter: "%~1"
If /I "%~1" EQU "1" (
	Set  GetIntgTimeToHHMMSS.cmd_Notwendig=1
	Goto GetIntgTimeToHHMMSS.cmd_Anfg
)
If /I "%~1" EQU "Sek0" (
	Set  GetIntgTimeToHHMMSS.cmd_Sek0=1
	Set  GetIntgTimeToHHMMSS.cmd_Notwendig=1
	Goto GetIntgTimeToHHMMSS.cmd_Anfg
)

If %GetIntgTimeToHHMMSS.cmd_Sek0% EQU 1 (
	Set Dat_Sec0=%GetIntgTimeToHHMMSS.cmd_Zeit:~-3%
	Set GetIntgTimeToHHMMSS.cmd_Zeit=%GetIntgTimeToHHMMSS.cmd_Zeit:~0,-3%
) Else (
	Set Dat_Sec0=0
)

If "%GetIntgTimeToHHMMSS.cmd_Zeit%" EQU "" (Set GetIntgTimeToHHMMSS.cmd_Zeit=0)

Set /A Dat_Hour= %GetIntgTimeToHHMMSS.cmd_Zeit% / 3600
Set /A Zeit_I=  %GetIntgTimeToHHMMSS.cmd_Zeit% - ( %Dat_Hour% * 3600 )
Set /A Dat_Min= %Zeit_I% / 60
Set /A Zeit_I=  %Zeit_I%  - ( %Dat_Min% * 60 )
Set /A Dat_Sec= %Zeit_I%

:: set getintg & Set Dat_

%Call_%GetTimeFormat

If %GetIntgTimeToHHMMSS.cmd_Notwendig% EQU 0 (
	Set Dat_TimeHHMMSS=%Dat_Hour%:%Dat_Min%:%Dat_Sec%
	Rem --- wenn mit Millisek: diese dranhaengen
	If %GetIntgTimeToHHMMSS.cmd_Sek0% EQU 1 (
		Set Dat_TimeHHMMSS=%Dat_TimeHHMMSS%.%Dat_Sec0%
	)
	Goto GetIntgTimeToHHMMSS.cmd_NoNotw
)

Set GetIntgTimeToHHMMSS.cmd_Teil=0

If %Dat_iHour% GTR 0 (Set GetIntgTimeToHHMMSS.cmd_Teil=3)

If %Dat_iMin% GTR 0 (
If %GetIntgTimeToHHMMSS.cmd_Teil% EQU 0 (
Set GetIntgTimeToHHMMSS.cmd_Teil=2
) )

If %Dat_iSec% GTR 0 (
If %GetIntgTimeToHHMMSS.cmd_Teil% EQU 0 (
Set GetIntgTimeToHHMMSS.cmd_Teil=1
) )
Rem --- GetIntgTimeToHHMMSS.cmd_Teil: %GetIntgTimeToHHMMSS.cmd_Teil% 

Set Sek0=
:: If %GetIntgTimeToHHMMSS.cmd_Notwendig% EQU 1 (
If %GetIntgTimeToHHMMSS.cmd_Sek0% EQU 1 (Set Sek0=.%Dat_Sec0%)

If %GetIntgTimeToHHMMSS.cmd_Notwendig% EQU 1 (
If %GetIntgTimeToHHMMSS.cmd_Teil% EQU 0 (Set Dat_TimeHHMMSS=0%Sek0%)
If %GetIntgTimeToHHMMSS.cmd_Teil% EQU 1 (Set Dat_TimeHHMMSS=%Dat_iSec%%Sek0%)
If %GetIntgTimeToHHMMSS.cmd_Teil% EQU 2 (Set Dat_TimeHHMMSS=%Dat_iMin%:%Dat_Sec%%Sek0%)
If %GetIntgTimeToHHMMSS.cmd_Teil% EQU 3 (Set Dat_TimeHHMMSS=%Dat_Hour%:%Dat_Min%:%Dat_Sec%%Sek0%)

)

:GetIntgTimeToHHMMSS.cmd_NoNotw
%EchoLabel% :GetIntgTimeToHHMMSS.cmd_NoNotw
:: Set Dat_ & set zeit_
Set GetIntgTimeToHHMMSS.cmd=
Set GetIntgTimeToHHMMSS.cmd_Sek0=
Set GetIntgTimeToHHMMSS.cmd_Notwendig=
Set GetIntgTimeToHHMMSS.cmd_Zeit=
@%Call_%Call_Exit %0
Rem ^^^^^^^^^^ Ende %GetIntgTimeToHHMMSS.cmd% %Dat_TimeHHMMSS% ^^^^^^^^^^
@EXIT /B 0

:: ***CutEnde*** GetIntgTimeToHHMMSS.cmd


